
/* //////////////  Importation Standards   ///////// */

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>


#include "libabiutils.h"


#ifndef NEW
#define NEW(typ)                (typ*)malloc(sizeof(typ)) 
#define NEWN(typ, dim)          (typ*)malloc((unsigned long)(dim) * sizeof(typ))
#define REALLOC(typ, ptr, dim)  (typ*)realloc((void *) (ptr), (unsigned long)(dim) * sizeof(typ))
#define FREE(ptr)               free((Ptr) ptr)
#endif

/* -------------------------------------------- */
/* erreur					*/
/* -------------------------------------------- */
void Erreur(char *msg, int stat)
{
	fprintf(stderr, "Error: %s\n", msg);
	if (stat) exit(stat);
}

/* -------------------------------------------------------------------- */
void MyError(FILE *stream, int stat, char *fmt, ...)
{
   va_list args;

   va_start(args,fmt);
   (void)vfprintf(stream, fmt, args);
   (void)fputc((int)'\n', stream);
   va_end(args);
   (void)fflush(stream);

   if (stat > 0)
      exit(stat);

   return;

}



/* ---------------------------------------------------- */
/* uppercase string                                     */
/* ---------------------------------------------------- */
char *LowerStr(char *str)
{
    char *s;
    
    for (s = str ; *s ; s++)         
        if (IS_UPPER(*s))
            *s = TO_LOWER(*s);

    return str;
}

/* ---------------------------------------------------- */
/* uppercase string                                     */
/* ---------------------------------------------------- */
char *UpperStr(char *str)
{
    char *s;
    
    for (s = str ; *s ; s++)         
        if (IS_LOWER(*s))
            *s = TO_UPPER(*s);

    return str;
}


/*********************************************/
/*Enlever tous caracteres speciaux           */
/*(code ASCII<32)d'une chaine de caracteres */
/*Renvoie le nombre d'espaces enleves        */
/*********************************************/
int RemoveSpecialChar(char *s)
{

/*   char *s2=NULL; */
  int is, is2=0;
  int lgs;

  lgs=strlen(s);

/*   s2=NEWN(char, lgs+1); */
/*   if(s2==NULL) */
/*     MyError(stderr, 1, "not enough memory for string in RemoveSpecialChar\n"); */


  for(is=0; is<lgs; is++)
    {
      if((int)s[is] >= 32 && is2 <= is)
	{
	  s[is2]=s[is];
	  is2++;
	}

    }

  s[is2]='\000';
/*   strcpy(s, s2); */

/*   free(s2); */


  return(lgs-is2);
}
/*********************************************/
/*Enlever tous espaces                       */
/*(code ASCII=32)d'une chaine de caracteres  */
/*Renvoie le nombre d'espaces enleves        */
/*********************************************/
int RemoveSpace(char *s)
{

/*   char *s2=NULL; */
  int is, is2=0;
  int lgs;

  lgs=strlen(s);

/*   s2=NEWN(char, lgs+1); */
/*   if(s2==NULL) */
/*     MyError(stderr, 1, "not enough memory for string in RemoveSpace\n"); */


  for(is=0; is<lgs; is++)
    {
      if((int)s[is] != 32 && is2 <= is)
	{
	  s[is2]=s[is];
	  is2++;
	}

    }

  s[is2]='\000';
/*   strcpy(s, s2); */

/*   free(s2); */


  return(lgs-is2);
}
