/* ==================================================== */
/* @file: DTypes.h					*/
/* @purpose: basic data types				*/
/* history:						*/
/* 15/12/01 :  <Gloup> adapted from LXTypes.h		*/
/* ==================================================== */

#ifndef _H_DTypes

#define _H_DTypes

#ifndef _SYS_TYPES_H_
#include <sys/types.h>	/* standard Unix types		*/
#endif

/* ---------------------------------------------------- */
/* data types						*/
/* ---------------------------------------------------- */

#ifndef TRUE
#define TRUE	0x1	/* bool values	= TRUE		*/
#endif
#ifndef FALSE
#define FALSE	0x0	/*              = FALSE		*/
#endif

#if 0
typedef void 	*Ptr;	/* pointer			*/
#endif

typedef short	SBool;	/* boolean			*/

/* ---------------------------------------------------- */
/* useful macros					*/
/* ---------------------------------------------------- */

#ifndef NEW
#define NEW(type)		(type*) malloc(sizeof(type)) 
#endif

#ifndef NEWN
#define NEWN(type, dim) 	(type*) malloc((size_t)(dim)   \
					     * sizeof(type))
#endif

#ifndef REALLOC
#define REALLOC(type, ptr, dim)	(type*) realloc((void *) (ptr), \
					       (size_t)(dim) 	\
					     * sizeof(type))
#endif

#ifndef FREE
#define FREE(ptr)		free((void *) ptr)
#endif

#ifndef MAX
#define MAX(x,y) 		(((x) > (y)) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x,y) 		(((x) < (y)) ? (x) : (y))
#endif
#ifndef ABS
#define ABS(x) 			(((x) > 0)   ? (x) : -(x))
#endif

#endif
