

/* si la transformation s'ecrit y = R(x+t1)+t2                                  */
/* avec R rotation, t1 et t2 translation                                        */
/* la matrice 3*3 superieure gauche contient la rotation R                      */
/* attention la matrice est a l'envers  (fortran...???) */
/* le vecteur inferieur M[3] contient:                                          */
/* - le produit scalaire de la premiere colonne de R avec t1 + t2.x             */
/* - le produit scalaire de la deuxieme colonne de R avec t1 + t2.y             */
/* - le produit scalaire de la troisieme colonne de R avec t1 + t2.z            */
/* - 1.0 (facteur d'echelle)                                                    */
/* cad que M contient:                                                          */
/*     R[0][0]      R[1][0]      R[2][0]        0.0                     */
/*     R[0][1]      R[1][1]      R[2][1]        0.0                     */
/*     R[0][2]      R[1][2]      R[2][2]        0.0                     */
/*     R[0][0]*t1.x+R[1][0]*t1.y+R[2][0]*t1.z+t2.x  R[0][1]*t1.x+R[1][1]*t1.y+R[2][1]*t1.z+t2.y  R[0][2]*t1.x+R[1][2]*t1.y+R[2][2]*t1.z+t2.z  1.0 */


/************************************************/
/* typedef					*/
/************************************************/


/* type coordinates				*/

typedef struct coords {
  float x,y,z;
} COORDS;

typedef double         DtMatrix4x4[4][4]; /* from QBestFit*/

                        /* Matrice de rotation translation*/
                       /*(3*3) pour matrice de rotation de structure banque*/
                       /* en cases [0,0] a [2,2] (carre)*/
                       /*(1*3) vecteur verticale de translation de structure banque*/
                       /* il se trouve en cases [0,3], [1,3] et [2,3]*/
                       /*pas de vecteur de translation de structure requete*/
                       /* la derniere ligne est pour un facteur d'echelle*/



/**************************************************/
/*                     FUNCTION PROTOTYPES        */
/**************************************************/
void print_matrice4x4(DtMatrix4x4 a, char *name, FILE *pOut);
void print_vector(double *a, int n, char *name, FILE *pOut);
COORDS crdRotate(COORDS p,DtMatrix4x4 rmat);
double squared_distance(COORDS R,COORDS K);


/* 
 * Best fit matrix as proposed by:
 * Zuker & Somorjai, Bulletin of Mathematical Biology,
 * vol. 51, No 1, p 55-78, 1989.
 * 
 * c1, c2 two sets of coordinates to superpose.
 * len : the number of coordiantes of c1, c2.
 *
 * M, the 4x4 transforamtion matrix to pass from c2 to c2 superposed onto c1.
 *
 * Input: 
 *   c1, c2, and len must be given. 
 *   M should be passed, but is meaningless.
 * 
 * Output:
 *   c2 is superposed on c1.
 *   M, a transformation matrix ready for use.
 *
 */
double zuker_superpose(COORDS *c1, COORDS *c2, int len, DtMatrix4x4 M);
/* Calcul du RMS pour les coordonnees c1 et c2 et la matrice M deja calculee*/
double compute_RMS(COORDS *c1, COORDS *c2, int len, DtMatrix4x4 M);


