/* doz.c: 'Do Z' test/demo program for UNIX-like compression */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "zlib.h"
#include "libunz.h"


int main(int argc, char *argv[])
{
   FILE *inp, *out;
   gzFile  mygzfile;
   struct stat s;

   if (argc != 3) {
      (void)fprintf(stderr, "Usage: testlibunz <input> <output>\n");
      (void)fprintf(stderr, "   uncompress .Z or .gz input file\n");
      return -1;
   }
   if (argv[1][strlen(argv[1])-1] == 'Z' && argv[1][strlen(argv[1])-2] == '.') {

   	if ((inp = fopen(argv[1], "rb")) == NULL) {
      	   perror(argv[1]); exit(-1);
   	}
  	if (fstat(fileno(inp), &s) != 0) {
      	   perror(argv[1]); return -1;
   	}
        if ((out = fopen(argv[2], "wb")) == NULL) {
           perror(argv[2]); exit(-1);
        }
   	unZ(inp, out);
   	fclose(inp);
   	fclose(out);
   }
   else if (argv[1][strlen(argv[1])-1] == 'z' && argv[1][strlen(argv[1])-2] == 'g' &&
           argv[1][strlen(argv[1])-3] == '.') {
      if ((inp = tmpfile()) == NULL) {
         fprintf(stderr, "cannot open temporary file\n");
         return -1;
      }
      if ((mygzfile = gzopen(argv[1], "rb")) == NULL) {
         fprintf(stderr, "Cannot open gz file %s, exiting....\n",argv[1]);
      }
      if ((out = fopen(argv[2], "wb")) == NULL) {
         perror(argv[2]); exit(-1);
      }
      if (gz_uncompress(mygzfile, out) != 0) {
         fprintf(stderr, "Problem uncompressing gz file %s, exiting....\n",
                    argv[1]);
      }
      fclose(out);
      
   }
   else 
     fprintf(stderr, "input file %s must end in .Z or .gz\n",argv[1]);
   return 0;
}

