/**************************************************************************/
/*                                                                        */
/* statistiques pour swelfe (fichier provenant de yakusa)                */
/* modifie en fevrier 2005                                                */
/*                                                                        */
/**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> /*Pour memcpy et autres fonctions*/

#include "macros.h"
#include "mtd.h"
#include "libmtd_loglik.h"
#include "libmtd_modelio.h"
/********************************************************************************************************/
/* -----  statiques "prcalcules", evitant de relire le fichier contenant ces donnes	---------	*/
/********************************************************************************************************/
#include "ModelesStatic.h"

#include "swelfe.h"
#include "swalign.h"
#include "stats.h"

#define ERR_STAT 14

		/* local defines	*/
/*#define MYFREE(x)    if ((x)) free(x)*/

#define LENLINE		256		/* length of lines in Freq file	*/


#ifndef MIN
#define MIN(x, j)  {if(x<y) return x; return y; }
#endif
#ifndef MAX
#define MAX(x, j)  {if(x<y) return y; return x; }
#endif

		/* -----  statiques 	---------	*/
static double *sTable1Dim=NULL, *sTable2Dim=NULL;
static int ReadTableFreq(FILE *pFi, double **t1, double **t2);


static ModelSet *sMtdModelSet = NULL;

static int sNbGroupesStat=0;


static double CalculeProbaBiAli( int *tAnglesGp, int lgMot );


/*****************************************************************/
#if 0
int CalculToutesProbasIndepBi(tyProt *pQuery, tyParametres *pParms)
{
  int i;
  int verif;
  tyProt *pProt;

  if(sTable2Dim ==NULL || sTable1Dim ==NULL){
    fprintf(stderr, "CalculToutesProbasIndepBi:: Can't compute all the independant"
	    " and bi-conditionnal probabilities, the frequence tables are empty\n");
    return(PASBON);
  }
  i=0;
  if((pProt=Get_Prot_Fin(i))==NULL){
    fprintf(stderr, "CalculToutesProbasIndepBi:: No protein returned from minimier\n");
    return(PASBON);
  }
  if(pProt->pResult->tProbaIndep!=NULL) 
    if(pProt->pResult->tRMSDCroises == NULL || 
       (pProt->pResult->sumLogProbaIndep_Compatible !=1 && pProt->pResult->sumLogProbaBi_Compatible !=1))
      /*Dj tout calcul, rien  faire*/
      return(BON);
  
  while( pProt !=NULL) {
    if(pProt->pResult->tProbaIndep==NULL){ 
      verif=CalculProbaSimple(pQuery, pProt);
      if (verif==PASBON)
	fprintf(stderr, "CalculToutesProbasIndepBi:: Problem in computing probabilities for protein %s\n",
		pProt->nomProt);
    }
    if(pProt->pResult->tSHSPCompatibles==NULL){
      verif=TrouveSHSPCompatibles(pQuery, pProt, pParms);
      if (verif==PASBON)
	fprintf(stderr, "CalculToutesProbasIndepBi:: Problem in computing compatibilities for protein %s\n",
		pProt->nomProt);
    }
    if(pProt->pResult->sumLogProbaIndep_Compatible ==1){
      pProt->pResult->sumLogProbaIndep_Compatible=
	CalculProbaCompatibles(pProt->pResult->tProbaIndep, 
			       pProt->pResult->tSHSPCompatibles,
			       pProt->pResult->nbMots,
			       &(pProt->pResult->num1erSHSPMeilleurGp));
      if(pProt->pResult->sumLogProbaIndep_Compatible ==1)
	fprintf(stderr, "CalculToutesProbasIndep:: Problem in computing probability with "
		"compatibilities for protein %s\n",
		pProt->nomProt);
    }
    if(pProt->pResult->sumLogProbaBi_Compatible ==1){
      pProt->pResult->sumLogProbaBi_Compatible=
	CalculProbaCompatibles(pProt->pResult->tProbaBi, 
			       pProt->pResult->tSHSPCompatibles,
			       pProt->pResult->nbMots,
 			       &(pProt->pResult->num1erSHSPMeilleurGp));
       if(pProt->pResult->sumLogProbaBi_Compatible ==1)
	fprintf(stderr, "CalculToutesProbasBi:: Problem in computing probability with "
		"compatibilities for protein %s\n",
		pProt->nomProt);
   }

    i++;
    pProt=Get_Prot_Fin(i);
  }
  return(BON);

}

#endif

#if 0
/*****************************************************************/
int CalculToutesProbasMTD(SWResult *swres, tyProt *p0)
{

    /* pour lire le modele predefini  // ajoute par AL  */
    sMtdModelSet = &mysModelSet;

  if(sMtdModelSet ==NULL ){
    fprintf(stderr, "CalculToutesProbasMTD:: Can't compute all the probabilities with MTD model"
	    " , the frequence tables are empty\n");
    return(PASBON);
  }

  if(swres->nmatch <= 0) {
    fprintf(stderr, "CalculToutesProbasMTD:: No match\n");
    return(PASBON);
  }

  if (CalculProbaMtd( swres, p0) == PASBON) {
    fprintf(stderr, "CalculToutesProbasMTD:: Problem in computing probabilities for protein %s\n", p0->nomProt);
    return (PASBON);
  }
  return(BON);
  
}
#endif

/****************************************/
/*****************************************/
int Set_TableFreq(char *nomFi)
{
  FILE *pFi=NULL;
  int	res=BON;
  
  
  if(nomFi[0]=='\0'){
    sTable1Dim=mysTable1Dim;
    sTable2Dim=mysTable2Dim;
    sNbGroupesStat=mysNbGroupesStat;
  }
  else{
    if((pFi=fopen(nomFi, "rt")) == NULL) {
      fprintf(stderr, "Set_TableFreq:: can't open %s for statistics\n", nomFi);
      return PASBON;
    }
    
    res = ReadTableFreq(pFi, &sTable1Dim, &sTable2Dim);
    
    fclose(pFi);
  }
  return res;

}
/****************************************/
/*****************************************/
void Free_TableFreq()
{
  if(sTable1Dim!=mysTable1Dim)
    MYFREE(sTable1Dim);
  
  if(sTable2Dim!=mysTable2Dim)
    MYFREE(sTable2Dim);
}

/****************************************/
void  Free_MtdModel()
{
  if(sMtdModelSet != NULL && sMtdModelSet != (&mysModelSet))
    FreeModelSet(sMtdModelSet);
}
/******************************************/
/******************************************/

static int ReadTableFreq(FILE *pFi, double **t1, double **t2)
{
  int i, j, dum;
  char ligne[LENLINE]; 
  double *p2;
  


  /*   fgets(enTete, LENLINE, pFi) */


  /*Lecture de l'enTete: le nombre de groupes pour les stat*/


  if(fgets(ligne, LENLINE, pFi)==NULL)
    {	  
      fprintf(stderr, "ReadTable1Dim:: premature end of frequencies file\n");
      return(PASBON);
    }
  /*   fprintf(stderr,"ReadTableFreq:: ligne lue <%s>\n", ligne); */
  if(sscanf(ligne, "%d", &sNbGroupesStat) !=1)
    {
      fprintf(stderr, "bad format for number of groups in ReadTable1Dim <%s>\n", ligne);     
      return(PASBON);
    }

  NEWY(*t1, double, sNbGroupesStat);

  for(i=0; i<sNbGroupesStat; i++)
    {
      if(feof(pFi)!=0)
	{
	  fprintf(stderr, "ReadTableFreq:: premature end of frequencies file\n");
	  free(*t1);
	  return PASBON;
	}
      if(fgets(ligne, LENLINE, pFi)==NULL)
	{	  
	  fprintf(stderr, "ReadTableFreq:: premature end of frequencies file\n");
	  free(*t1);
	  return(PASBON);
	}
      /*       fprintf(stderr, "ReadTableFreq:: ligne lue (1) %s\n", ligne); */
      if(sscanf(ligne, "%d %lf", &dum, (*t1+i)) !=2)
	{
	  /* 	  fprintf(stderr, "ligne lue %s\n", ligne); */
	  fprintf(stderr, "ReadTableFreq:: bad format <%s>\n", ligne);
	  free(*t1);
	  return(PASBON);
	}
      /*       fprintf(stderr, "lu angle %d:  %lf\n", i,  (*t1)[i]);  */
    }/*fin for i*/

  if(fgets(ligne, LENLINE, pFi)==NULL) {
    /* lit ligne avant les frequences de doublets	*/
    fprintf(stderr, "ReadTableFreq:: Cannot read line before 2-uple in frequency file\n");
    free(*t1);
    return PASBON;
  }
  /*   fprintf(stderr, "ReadTableFreq:: ligne lue (2) %s\n", ligne); */
 
  NEWY(*t2, double, sNbGroupesStat * sNbGroupesStat);
  p2 = *t2;
  /* read 2-uples proba	*/
  for(i=0; i<sNbGroupesStat; i++) {
    for(j=0; j<sNbGroupesStat; j++) {
      if(feof(pFi) != 0 || fgets(ligne, LENLINE, pFi) == NULL) {
	fprintf(stderr, "ReadTableFreq:: premature end of frequencies file\n");
	free(*t1);
	free(*t2);
	return(PASBON);
      }
      /* read P(i and j)	*/

      if(sscanf(ligne, "%d %d %lf",&dum,&dum,p2) != 3) {
	fprintf(stderr, "ReadTableFreq:: bad format (2) <%s>\n", ligne);
	free(*t1);
	free(*t2);
	return(PASBON);
      }
      /* p2[i][j] == P(j|i) = P(i and j)/P(i)	*/
      *p2 /= (*t1)[i];
      p2++;
    }
  }
  
  return(BON);

}

#if 0
/******************************************************************************************/
/* Calculer la proba de chaque match (qui est la multiplication de la freq de chaq angle  */
/*de la proteine, pas de la query)                                                        */
/* Calcul aussi la proba conditinelle 2-uple des matchs                                   */
/*Calculer la proba totale, somme des log base 10 des proba des matchs                    */
/* En entre: query et protein de banq                                                    */
/* Mais ncessite aussi que les 2 tables de frequence/proba aient t lues (sTable2Dim et */
/* sTable1Dim, lues dans Set_TableFreq qui appelle ReadTableFreq)                         */
/* Rq: Les 2 proba sont lues et calcules en mme temps car ces proba sont gnres par   */
/* le mme pgm et mises dans le mme fichier                                              */
/* En sortie:                                                                             */ 
/*      dans swres->tProbaIndep : tableau contenant proba (indep)de chaq SHSP             */
/*      dans swres->tProbaBi : tableau contenant proba (Bi) de chaq SHSP                  */
/*      dans swres->sumLogProbaIndep: somme des log des proba indep des SHSP              */
/*      dans swres->sumLogProbaBi: somme des log des proba bi des SHSP                    */
/* Rq: N'utilise pas la fonction CalculeProbaBiAli car ici calcul  la fois les proba bi et indep*/ 
/******************************************************************************************/
int CalculProbaSimple(SWResult *swres, tyProt *p0)
{

  int iP, iAli, j, prev = -1;
  double probaP = 1.0L, probaBi = 1.0L, sum = 0.0L, sumBi = 0.0L;
  int angleGroupe = -1;
  float div;
  int longueur;

  if(sTable1Dim == NULL)
    {fprintf(stderr, "pb: pas de table des frequences des angles\n"); return(PASBON);}
  if(sTable2Dim == NULL)
    {fprintf(stderr, "pb: pas de table des frequences des angles\n"); return(PASBON);}

/*   deja fait dans swalign  */
/*  NEWY(swres->tProbaIndep, double, swres->nmatch); */
/*  NEWY(swres->tProbaBi, double, swres->nmatch);  */

  div=360/(float)sNbGroupesStat;

  for (iAli=0; iAli<swres->nmatch; iAli++)
    {

      iP = swres->posd1[iAli];
      probaP = 1;
      longueur = swres->posf1[iAli] - swres->posd1[iAli] + 1;
      for(j = 0; j < longueur; j++)
	{
	 
	  /*Proba=multiplication de la freq de chaq angle*/

	  /*Trouver la "classe" de l'angle dans les angles discretises de la table des frequences*/
 
	  angleGroupe = (int)floor((swres->prot1->tAngles[iP+j]/(float)DIVANGLE+(float)180)/div);
	  if (angleGroupe == sNbGroupesStat)
		angleGroupe = 0;
	  if(angleGroupe > sNbGroupesStat) {
	     fprintf(stderr, "pb au recodage des angles dans CalculProbaSimple 1 angle: %f, angleGroupe: %d, nbGroupes: %d\n",
		     swres->prot1->tAngles[iP+j]/(float)DIVANGLE, angleGroupe, sNbGroupesStat);
	     fprintf(stderr, "iP: %d lgMot: %d j: %d\n", iP, longueur, j); 
	     exit(ERR_STAT);
	  }

	  probaP *= sTable1Dim[angleGroupe];

				/* probas 2-uple	*/
          if (j == 0)
             probaBi = probaP;
          else			/* P(j si prev)	*/
             probaBi *= sTable2Dim[prev*sNbGroupesStat + angleGroupe];

          prev = angleGroupe;
	}

      swres->tProbaIndep[iAli]   = probaP;
      swres->tProbaBi[iAli] = probaBi;
 
     /*La proba totale est la somme des log des proba de chaq SHSP*/
      sum += log10((double)swres->tProbaIndep[iAli]);
      sumBi += log10((double)swres->tProbaBi[iAli]);
    }

			/* set the overall probability	*/
  swres->sumLogProbaIndep = sum;
  swres->sumLogProbaBi = sumBi;
  return(BON);


}

#endif
/************************************************************/
/*          Calcul des probabilits pour un match           */
/*  en ayant deja ses angles recodes                        */
/************************************************************/

static double CalculeProbaBiAli( int *tAnglesGp, int lgMot )
{ /*Fonction CalculeProbaBiAli*/

  int  j;
  double probaBi = 1.0L;

      for(j = 0; j < lgMot; j++){
	 
	/*Proba=multiplication de la freq de chaq angle*/
	/*Trouver la "classe" de l'angle dans les angles discretises de la table des frequences*/
	if(tAnglesGp[j] > sNbGroupesStat || tAnglesGp[j]<0) {
	  fprintf(stderr, "pb au recodage des angles dans CalculProbaBiAli, angleGroupe: %d, nbGroupes: %d\n",
		  tAnglesGp[j],  sNbGroupesStat);
	  fprintf(stderr, " lgMot: %d j: %d\n", lgMot, j); 
	  exit(ERR_STAT);
	}
	
	
	/* probas 2-uple	*/
	if (j == 0)
	  probaBi = sTable1Dim[tAnglesGp[j]];
	else			/* P(j si prev)	*/
	  probaBi *= sTable2Dim[tAnglesGp[j-1]*sNbGroupesStat + tAnglesGp[j]];
      }

      return(probaBi);

}



/**********************************************	*/
/* Calculer la proba de chaque match par MTD	*/
/* selon le modele MTD mtdmodel			*/
/*********************************************	*/
int CalculProbaMtd(SWResult *swres, tyProt *p0)
{
  int iP, iAli, j, maxwlen, nbMTDGroupesStat=0, g;
  double sum;
  float div;
  int *indx;		/* index of angles in MTD model states	*/
  int longueur;
  
  
  /* pour lire le modele predefini  // ajoute par AL*/
  sMtdModelSet = &mysModelSet;
  
  if(sMtdModelSet==NULL) {
    fprintf(stderr, "CalculProbaMtd:: no MTD model\n");
    return(PASBON);
  }
  
  
  nbMTDGroupesStat = sMtdModelSet->model[0]->nstates;
  div=360/(float)nbMTDGroupesStat;
  
  /* take longest alignment length	*/
  maxwlen = -1;

 
  for (iAli=0; iAli< (swres->nmatch); iAli++) {
    longueur = MAX(swres->posf1[iAli] - swres->posd1[iAli] + 1,swres->posf0[iAli] - swres->posd0[iAli] + 1 );
    if (longueur > maxwlen)
      maxwlen = longueur;
  }
  /* allocate indx array which will contain recoded angles	*/
  /* for word "iAli", recoding being made in the model	states	 */

  NEWY(indx, int, maxwlen);
  
  sum = 0.0L;
  
  for (iAli=0; iAli< swres->nmatch; iAli++) {
    

    /*proba pour p1 :*/
    longueur = swres->posf1[iAli] - swres->posd1[iAli] + 1;    
    iP = swres->posd1[iAli];
    
    for(j = 0; j < longueur; j++) {
      
      /* Proba=donnee par le MTD model model[0]	*/
      /* Trouver la "classe" de l'angle dans le modele donne  */	
      
      indx[j] = (int)floor((swres->prot1->tAngles[iP+j]/(float)DIVANGLE+(float)180)/div);
      if (indx[j] == nbMTDGroupesStat)
	indx[j] = 0;
      
      if(indx[j] > nbMTDGroupesStat) {
	fprintf(stderr, "problem in angle recoding in CalculProbaMtd avec %s indx[%d]= %d, max %d, angle %d (%d), : %f\n", 
		swres->prot1->nomProt, j, indx[j], nbMTDGroupesStat, 
		iP+j, (int)(swres->prot1->tNumPDB[iP+j].num[1]), swres->prot1->tAngles[iP+j]/(float)DIVANGLE);
	fprintf(stderr, "mot %d: %d a %d\n", iAli, iP,  longueur);
	for(g=0; g> longueur; g++) {
	  fprintf(stderr, "angle %d %f\n", iP+g, swres->prot1->tAngles[iP+g]/(float)DIVANGLE);
	}
        MYFREE(indx);
	return(PASBON);
      }
    
    }
    /* on calcule les probas !!! PAS !!!! en log10	*/
    /* (ProbSingle les retourne en proba entre 0 et 1 donc)	*/
    
    /*Pour les 8 1ers angles, on calcule avec les proba bi*/
    /* probabi = p0 * p(1|0) *p(2|1)*etc..*/
    /*Si le mot est trop petit : on ne calcule sa proba que avec les proba bi*/
    if(longueur <= sMtdModelSet->model[0]->order){
      swres->tProbaMTD_p1[iAli]=CalculeProbaBiAli(indx, longueur);
    }
    else{ /*Sinon, on calcule les LG_MIN_SHSP_MTD-1 1ers avec les proba bi et la suite avec les mtd*/
      swres->tProbaMTD_p1[iAli]=CalculeProbaBiAli(indx, sMtdModelSet->model[0]->order);
      /* ProbSingle computes MTD beginning at index+order taking into account index,index+1,... */
      swres->tProbaMTD_p1[iAli] *= ProbSingle(indx, longueur,  sMtdModelSet->model[0]);
    }
    /*La proba totale est la somme des log_10 des proba de chaq match*/
    swres->tProbaMTD_p1[iAli] = log10((double)swres->tProbaMTD_p1[iAli]);
  
  
  /* set the overall probability	*/
  swres->sumLogProbaMTD_p1 += swres->tProbaMTD_p1[iAli];

    /*proba pour p0 : idem  */
    longueur = swres->posf0[iAli] - swres->posd0[iAli] + 1;    
    iP = swres->posd0[iAli];
    
    for(j = 0; j < longueur; j++) {
      
      indx[j] = (int)floor((p0->tAngles[iP+j]/(float)DIVANGLE+(float)180)/div);
      if (indx[j] == nbMTDGroupesStat)
	indx[j] = 0;
      
      if(indx[j] > nbMTDGroupesStat) {
	fprintf(stderr, "problem in angle recoding in CalculProbaMtd avec %s indx[%d]= %d, max %d, angle %d (%d), : %f\n", 
		p0->nomProt, j, indx[j], nbMTDGroupesStat, 
		iP+j, (int)(p0->tNumPDB[iP+j].num[1]), p0->tAngles[iP+j]/(float)DIVANGLE);
	fprintf(stderr, "mot %d: %d a %d\n", iAli, iP,  longueur);
	for(g=0; g> longueur; g++) {
	  fprintf(stderr, "angle %d %f\n", iP+g, swres->prot1->tAngles[iP+g]/(float)DIVANGLE);
	}
        MYFREE(indx);
	return(PASBON);
      }
    }

    if(longueur <= sMtdModelSet->model[0]->order){
      swres->tProbaMTD_p0[iAli]=CalculeProbaBiAli(indx, longueur);
    }
    else{
      swres->tProbaMTD_p0[iAli]=CalculeProbaBiAli(indx, sMtdModelSet->model[0]->order);
      swres->tProbaMTD_p0[iAli] *= ProbSingle(indx, longueur,  sMtdModelSet->model[0]);
    }
    swres->tProbaMTD_p0[iAli] = log10((double)swres->tProbaMTD_p0[iAli]);
    
    swres->sumLogProbaMTD_p0 += swres->tProbaMTD_p0[iAli];
    
    
    
  }
  MYFREE(indx);
  
  return(BON);
}

#if 0
/******************************************************************/
/* Trouver le groupe de SHSP compatibles spatialement qui donne   */
/*   la meilleur probabilit (meilleur somme des log(proba)),     */
/*   qq soit le type de proba                                     */
/*                                                                */
/*   En entre: tProba: tableau contenant les proba de chaq SHSP  */
/*              tCompatibles: tableau des compatiblites           */
/*		(cf CalculRMSD.c, TrouveSHSPCompatibles)          */
/*              nbSHSP, nombre de SHSP                            */
/*                                                                */
/*  En sortie: renvoie la somme des log des proba de ce groupe    */
/*             renvoie 1 s'il y a eu un pb                        */
/*              num1erSHSPMeilleurGp: cf. ci dessous              */
/* num1erSHSPMeilleurGp du pProt est modifie: il contient l'indice*/
/* du 1er SHSP du meilleur groupe de SHSPSs                       */
/*                                                                */
/* La "meilleure" probalit est la plus faible des proba, donc    */
/* la plus petite des sommes des log (log(<1) est < 0)            */
/*                                                                */
/* Structure du tableau des compatibles                           */
/* Si  c'est le 1er d'un groupe                                   */
/*       -> toujours l'indice du suivant multipli par -1         */
/* Si au milieu du groupe (hors 1er et dernier)                   */ 
/*       -> le numero du SHSP suivant du groupe                   */
/* Si c'est la fin d'un groupe                                    */
/*       -> l'indice de la case                                   */
/* Et si le SHSP est seul, la case contiendra sont numero*-1      */
/*                                                                */
/******************************************************************/
double CalculProbaCompatibles(double *tProba, int *tCompatibles, int nbSHSP, int *num1erSHSPMeilleurGp)
{
  
  
  int iPremier=0, iPremierBestScore=0, iCourant=0, nbSHSPVus=0;
  int fin=BON;
  double sumLogProba=0;
  double bestLogProba=0;
  double logProbaCourant=0;
  int k;
  
  if(nbSHSP <=0 ){
    fprintf(stderr, "CalculProbaCompatibles:: negative number of SHSPs (%d)\n", nbSHSP);
    return(1);
  }
  if(tProba==NULL ){
    fprintf(stderr, "CalculProbaCompatibles:: no probabilities (tProba: NULL)\n");
    return(1);
  }
  if(tCompatibles==NULL){
    fprintf(stderr, "CalculProbaCompatibles:: Can't compute probabilites of spatially compatible SHSPs:\n"
	    "There is no table of compatibility (tCompatibles)\n");
    return(1);
  }
  
  while (nbSHSPVus < nbSHSP){
    
    if(iCourant >= nbSHSP){
      fprintf(stderr, "Out of range: i: %d, size of tCompatibles: %d\n", iCourant, nbSHSP );
      fprintf(stderr, "iCourant: %d, iPremier: %d, nbSHSPVus: %d, nbSHSP: %d\n", 
	      iCourant, iPremier, nbSHSPVus, nbSHSP);
      fprintf(stderr, "tCompatibles::\n");
      if(tCompatibles != NULL){
	for(k=0; k<nbSHSP; k++)
	  fprintf(stderr, "tCompatibles[%d]: %d\n", k, tCompatibles[k]);
      }
      exit(ERR_STAT);
    }
    /*     fprintf(stderr, "iCourant: %d, tCompatibles[%d] %d, nbSHSPVus: %d, nbSHSP: %d\n",  */
    /* 	    iCourant, iCourant, tCompatibles[iCourant] , nbSHSPVus, nbSHSP); */
    /*   if(tProba[iCourant]<0)*//*Les mtd ne sont plus des log maintenant; Cas des mtd: c'est dj un log10, donc <0*/
    /*       logProbaCourant=tProba[iCourant]; */
    /*     else */
    logProbaCourant=log10(tProba[iCourant]);
    /*     fprintf(stderr, "log(%f)=%f", tProba[iCourant], logProbaCourant); */
    
    if(tCompatibles[iCourant] <= 0 ){
      if( fin == PASBON) {
	fprintf(stderr, "Out of range: i: %d, size of tCompatibles: %d\n", iCourant, nbSHSP );
	fprintf(stderr, "iCourant: %d, iPremier: %d, nbSHSPVus: %d, nbSHSP: %d\n", 
		iCourant, iPremier, nbSHSPVus, nbSHSP);
	fprintf(stderr, "tCompatibles::\n");
	if(tCompatibles != NULL){
	  for(k=0; k<nbSHSP; k++)
	    fprintf(stderr, "tCompatibles[%d]: %d\n", k, tCompatibles[k]);
	}
	exit(ERR_STAT);
      }
      if ( tCompatibles[iCourant] == iCourant*-1 ){ 
	/*Si SHSP tout seul*/
	iPremier=iCourant;
	/* 	fprintf(stderr, "Est tout seul\n"); */
	if(logProbaCourant < bestLogProba){
	  bestLogProba = logProbaCourant;
	  iPremierBestScore=iPremier;
	  /* 	  fprintf(stderr, "Nouveau meilleur groupe iPremier: %d tCompatibles[iPremier]: %d\n",  */
	  /* 		  iPremierBestScore, tCompatibles[iPremierBestScore]); */
	}
	iCourant++;
	iPremier=iCourant;
      }
      else{
	/*Si 1er SHSP d'un groupe*/
	/* 	fprintf(stderr, "c 1 debut de groupe\n"); */
	fin=PASBON;
	sumLogProba=logProbaCourant;
	iPremier=iCourant;
	iCourant=tCompatibles[iCourant]*-1;
      }
      nbSHSPVus++;
    }
    else{
      /*Cherche le debut de groupe suivant (ou shsp seul)*/
      if(fin == BON){
	iCourant++;
	/* 	fprintf(stderr, "cherche debut\n"); */
      }
      else{
	if( tCompatibles[iCourant] == iCourant ){
	  /*Si c'est la fin d'un groupe*/
	  fin=BON;
	  sumLogProba+=logProbaCourant;
	  if(sumLogProba < bestLogProba){
	    bestLogProba = sumLogProba;
	    iPremierBestScore=iPremier;
	    /* 	    fprintf(stderr, "Nouveau meilleur groupe iPremier: %d tCompatibles[iPremier]: %d\n",  */
	    /* 		    iPremierBestScore, tCompatibles[iPremierBestScore]); */
	  }
	  iCourant=iPremier+1;
	  /* 	  fprintf(stderr, "c la fin\n"); */
	} 
	else{
	  /*Si c'est 1 SHSP au milieu d'un groupe */
	  sumLogProba+=logProbaCourant;
	  iCourant=tCompatibles[iCourant];
	  /* 	  fprintf(stderr, "Au milieu\n"); */
	}
	nbSHSPVus++;  
      } /*fin if else (fin == BON)*/
    }/*fin if else (tCompatibles[iCourant] <0 )*/
  }/*fin while*/
  
  /*   fprintf(stderr, "CalculProbaCompatibles:: bestLogProba: %f, iPremier: %d\n", bestLogProba, iPremier); */
  *num1erSHSPMeilleurGp=iPremierBestScore;
  
  return(bestLogProba);
  
}
#endif

/* ----------------------------------------------------------	*/
/* Compute stat on SWResult					*/
/* ----------------------------------------------------------	*/
/*void ComputeStat(SWResult *sw, double *ps, double *pbi, */

/****************************************************/
/*        affichage des probas                      */
/****************************************************/
void affichage_proba(int **tproba_simple,  int ****tpar_paire, FILE* sortie){
  
  int i, j;
#if  TOUTES_TRANSITIONS
  int k, l;
#endif
  int  nbclasses = DEFAULT_ANGLE_MAX;
  fprintf(sortie,"@ probabilites simples \n");
  
  for (i = 0; i<nbclasses; i++){
    fprintf(sortie,"@ %20d", i);
    for (j=0; j<nbclasses; j++)
      fprintf(sortie,"%20d", tproba_simple[i][j]);
    fprintf(sortie,"\n"); 
  }
  
#if  TOUTES_TRANSITIONS
  fprintf(sortie,"@ par paires \n");
  
  
  for (i=0; i<ORDRE_MARKOV; i++){
    fprintf(sortie,"@ ordre de la chaine %20d \n", i+1);
    for(j=0; j<nbclasses; j++){
      /*     if(remplissage[i][j] != 0){ */
      fprintf(sortie,"@ angles precedants : %20d \n", j);
      for(k=0; k<nbclasses; k++){
	fprintf(sortie,"@ %20d", k);
	for(l=0; l<nbclasses; l++)
	  fprintf(sortie,"%20d", tpar_paire[i][j][k][l]);
	fprintf(sortie,"\n"); 
	/*	} */
      }
    }
  }
#endif
}


/********************************************************/
/*  proba des angles                                     */
/* tproba_simple :  proba de transition entre 2 angles  */
/*  tproba_paire1 = idem mais en prenant en compte difference d'angle entre les 2 prcdants  */
/*  tproba_paire2 : id avec les angles prcdents  ...*/
/* 
   a-3   a-2   a-1   a0 
   a'-3  a'-2  a'-1  a'0
   proba simple : proba d'avoir une transition entre a0 et a'0
   proba par paire : proba d'avoir une transition entre a0 et a'0 sachant la transition entre a-1 et a'-1 (ordre 1)
*/
/********************************************************/

void OutputComptages(SWResult *swres, tyProt *p0, int **tproba_simple, int ****tpar_paire, int option){
  
  int  j, iAli, longueur, pp0, pp1;
#if TOUTES_TRANSITIONS
  int k, angle0, angle1;
  int p, q; /* positions de memoire_angles*/
  int memoire_angles[ORDRE_MARKOV];  /*contient les angles precedants du tableau pour ne pas les recalculer*/
#endif
  

  /********************************/
  /*     proba simple             */
  /**********************************/

  /*on parcourt tous les matchs*/
  for(iAli=0; iAli<swres->nmatch; iAli++){
    
    longueur = (int)(strlen(swres->sali[iAli]));    /*  longueur de l'alignement  */
    pp0 = pp1 = 0;   /*pointeurs sur la position courante dans le match pour chaque proteine (permet de decaler si insertions / deletions)  */
    for (j=0; j<longueur; j++){ /*pour toute la longueur de chaque match*/
      if(swres->sali[iAli][j] == DELET) 
	pp1 ++;
      else if(swres->sali[iAli][j] == INSER) 
	pp0 ++;
      
      else {  /*si  substitution*/
	
	/*ici, on recupere, pour chaque proteine, l'angle du match'iAli'( de 0  nmatch)  la position j (de 0  la longueur du match)    */
	/*on incremente de 1 le tableau de la faon suivante : tproba_simple[angle prot0][angle prot1]*/
	tproba_simple[p0->tAnglesRecodes[swres->posd0[iAli] + pp0]] [swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1]] ++;
	pp0 ++;
	pp1 ++;
      }
    }
  }
  
#if TOUTES_TRANSITIONS
  
  /********************************/
  /*     proba par paire          */
  /********************************/


  if(option == 1){
  /*on parcourt tous les matchs*/
  for(iAli=0; iAli<swres->nmatch; iAli++){
    
    longueur = (int)(strlen(swres->sali[iAli]));    /*  longueur de l'alignement  */
    p=0;  /*position du tableau memoire : ce tableau sert a memoriser les angles precedents pour ne pas les recalculer*/
    
    for(j=0; j<ORDRE_MARKOV; j++){  /*tableau contenant les differences d'angles, mis  -1 par defaut*/
      memoire_angles[j] = -1;
    }
    
    pp0 = pp1 = 0;  /*pointeurs sur la position courante dans le match pour chaque proteine (permet de decaler si insertions / deletions)  */
    
    for (j=0; j<longueur; j++){                     /*pour toute la longueur de chaque match*/
      
      if(swres->sali[iAli][j] == DELET){  /*deletion : on s'arrete*/
	pp1 ++;
	memoire_angles[p] = -1;
	augmente_p(&p);
	continue;   }
      
      else if(swres->sali[iAli][j] == INSER){ /*insertion : on s'arrete*/
	memoire_angles[p] = -1;	    
	augmente_p(&p);
	pp0 ++;
	continue;  }
      
      else {
	
	/*ici,on remplit le tableau pour k=ordre de markov courant et l = moyenne des angles  la position de markov courante*/
	/*on incremente de 1 le tableau de la faon suivante : tpar_paire[ordre markov][diff angles precedants][angle prot0][angle prot1]*/
	
	
	/*calcul des angles de p0 et p1 et verification du resultat!!*/	
	angle0 = p0->tAnglesRecodes[swres->posd0[iAli] + pp0];
	angle1 = swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1];
	
	if (angle0 >=DEFAULT_ANGLE_MAX  || angle0 < 0 ||  angle1 >=DEFAULT_ANGLE_MAX  || angle1 < 0)
	  fprintf(stderr, " erreur angle !!!\n");
	
	else {
	  k=0;  /*ordre de markov courant*/
	  /*tant que k est inferieur a l'ordre de markov max  et le tableau ne contient pas -1 : on ne prend pas en compte les angles precedents qui sortent de l'alignement*/
	  /*on prend au maximum ORDRE_MARKOV cas, et on verifie k<q pour au cas o*/
	  q=p-1; /*pointeur sur le tableau memoire_angles pour se deplacer sur les ORDRE_MARKOV dernieres cases*/
	  if(q==-1)
	    q=ORDRE_MARKOV-1;
	  while(k<ORDRE_MARKOV &&  memoire_angles[q] != -1 ){
	    tpar_paire[k][memoire_angles[q]][angle0] [angle1] ++;
	    k++; 
	    q--;
	    if(q == -1)
	      q = ORDRE_MARKOV-1;
	  }
	  memoire_angles[p] = abs((angle0 +  angle1)/2);
	  augmente_p(&p);	    
	}
	pp0 ++;
	pp1 ++ ;	    
      }  /*fin du j != 0*/
    } /*fin j*/
  }/*fin iAli*/
  }/*fin option 1*/

  
  if(option == 2){  /*moyenne sur les angles actuels, on garde les angles precedents*/
    
    for(iAli=0; iAli<swres->nmatch; iAli++){
      
      longueur = (int)(strlen(swres->sali[iAli]));    /*  longueur de l'alignement  */
      p=0;  /*position du tableau memoire : ce tableau sert a memoriser les angles precedents pour ne pas les recalculer*/
      
      pp0 = pp1 = 0;  /*pointeurs sur la position courante dans le match pour chaque proteine (permet de decaler si insertions / deletions)  */
      
      for (j=0; j<longueur; j++){                     /*pour toute la longueur de chaque match*/
	
	if(swres->sali[iAli][j] == DELET){  /*deletion : on s'arrete*/
	  pp1 ++;
	  continue;   }
	
	else if(swres->sali[iAli][j] == INSER){ /*insertion : on s'arrete*/
	  pp0 ++;
	  continue;  }
	
	else {
	  /*on incremente de 1 le tableau de la faon suivante : tpar_paire[ordre markov][diff angles][angle prec prot0][angle prec prot1]*/
	  
	  /*calcul des angles de p0 et p1 et verification du resultat!!*/	
	  angle0 = p0->tAnglesRecodes[swres->posd0[iAli] + pp0];
	  angle1 = swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1];
	  
	  if (angle0 >=DEFAULT_ANGLE_MAX  || angle0 < 0 ||  angle1 >=DEFAULT_ANGLE_MAX  || angle1 < 0){
	    fprintf(stderr, " erreur angle !!!\n");
	    continue;
	  }
	  
	  memoire_angles[0] = abs((angle0 +  angle1)/2);
	  
	  k=0;  /*ordre de markov courant*/
	  /*tant que k est inferieur a l'ordre de markov max  et le tableau ne contient pas -1 : on ne prend pas en compte les angles precedents qui sortent de l'alignement*/
	  
	  while(k<ORDRE_MARKOV && pp0 > k && pp1 > k){
	    if(swres->sali[iAli][j-k] == INSER || swres->sali[iAli][j-k] == DELET)
	      continue;
	    if (p0->tAnglesRecodes[swres->posd0[iAli] + pp0 -k]  >=DEFAULT_ANGLE_MAX  || p0->tAnglesRecodes[swres->posd0[iAli] + pp0 -k ] < 0 || swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1 -k ] >=DEFAULT_ANGLE_MAX  || swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1 -k ] < 0)
	      continue;
	    
	    tpar_paire[k][memoire_angles[0]][p0->tAnglesRecodes[swres->posd0[iAli] + pp0 -k ]] [swres->prot1->tAnglesRecodes[swres->posd1[iAli] + pp1 -k]] ++;
	    k++; 
	  }
	}
	pp0 ++;
	pp1 ++ ;	    
      } /*fin j*/
    }/*fin iAli*/
  }/*fin option 1*/
 

#endif 
}

void augmente_p (int *p){
  
  if(*p < ORDRE_MARKOV-1)
    *p+=1;
  else
    *p=0;
}



void FreeTransitions ( int **tproba_simple,  int ****tpar_paire){
  int i;
#if  TOUTES_TRANSITIONS
  int j, k;
#endif
  
  
  for(i=0; i< DEFAULT_ANGLE_MAX; i++)
    if (tproba_simple[i] != NULL)
      free(tproba_simple[i]);
  
  free(tproba_simple);   
  
  
#if  TOUTES_TRANSITIONS
  for(i=0; i<ORDRE_MARKOV; i++){
    if (tpar_paire[i] != NULL)
      for(j=0; j< DEFAULT_ANGLE_MAX; j++){
	if (tpar_paire[i][j] != NULL)
	  for(k=0; k< DEFAULT_ANGLE_MAX; k++){
	    if (tpar_paire[i][j][k] != NULL)
	      free(tpar_paire[i][j][k]);
	  }
	free(tpar_paire[i][j]);
      }
    free(tpar_paire[i]);
  }
#endif
  free(tpar_paire);
  
}




/******************************************************************/
/*                                                                */
/*    additionne les resultats pour 1 proteine contre une banque  */
/*     en fonction de la longueur du match                        */
/******************************************************************/



SommeRes *NewSommeRes(void){
  
  SommeRes *smres =  NEW(SommeRes); 
  
  if (! smres)
    return NULL;
  
  smres->n = 0.0L; 
  smres->s = 0.0L; 
  smres->r = 0.0L; 
  smres->m0 = 0.0L;
  smres->m1 = 0.0L;
  
  return smres;  
}


void AddSommeRes (SommeRes **smres, SWResult *swres){
  
  int i;
  int lg;
  
  for(i=0; i<swres->nmatch; i++){
    lg = (int)strlen(swres->sali[i]);  
    if(swres->group[i] < NB_GROUPE_MAX){
      if(lg >= LONGUEUR_STAT)
	lg = LONGUEUR_STAT-1;
      smres[lg]->n ++; 
      smres[lg]->s += swres->score[i]; 
      smres[lg]->r += swres->rms[i]; 
      smres[lg]->m0 += swres->tProbaMTD_p0[i];
      smres[lg]->m1 += swres->tProbaMTD_p1[i];
    }
  }
}


/*pour chaque tableau, on incremente la case correspondant au numero du groupe et a la longueur du score correspondant*/
void AddGroupes (SommeRes ***smres, SWResult *swres){

  int i;
  int lg;
  
  for(i=0; i<swres->nmatch; i++){
    lg = (int)strlen(swres->sali[i]);  
    if(swres->group[i] < NB_GROUPE_MAX){
      if(lg >= LONGUEUR_STAT)
	lg = LONGUEUR_STAT-1;
      smres[swres->group[i]][lg]->n ++; 
      smres[swres->group[i]][lg]->s += swres->score[i]; 
      smres[swres->group[i]][lg]->r += swres->rms[i]; 
      smres[swres->group[i]][lg]->m0 += swres->tProbaMTD_p0[i];
      smres[swres->group[i]][lg]->m1 += swres->tProbaMTD_p1[i];
    }
  }
}


void PrintSommeRes (SommeRes **smres){
  int i;

    for (i=5; i<LONGUEUR_STAT; i++)
      fprintf(stdout,"%3d %6d  %10.2f  %8.2f  %10.2f %10.2f \n", i, smres[i]->n, smres[i]->s, smres[i]->r, smres[i]->m0, smres[i]->m1 );

}

void FreeSommeRes (SommeRes **smres, SommeRes ***Groupes){
  int i, j;
  

  for(i=0; i<LONGUEUR_STAT; i++)
    if (smres[i] != NULL)
      free(smres[i]);

  free(smres);
  
  for (i = 0; i < NB_GROUPE_MAX; i++){
    if (Groupes[i] != NULL) {
      for(j=0; j<LONGUEUR_STAT; j++){
	if (Groupes[i][j] != NULL)
	  free(Groupes[i][j]);	
      }
      free(Groupes[i]);
    }    
  }
  
  
  free(Groupes);  
  
}

void  calcul_mtd (SWResult *swres, FILE *fich, tyProt *p0){
  
  
  int i,j,  longueur;
  
  for(i=0; i< swres->nmatch; i++){
    
    fprintf(fich, "HEADER \n");
    longueur = swres->posf0[i] - swres->posd0[i] + 1;
    for(j=0; j< longueur ; j++)
      
      fprintf(fich, "ZZZ  %d %f %f %f \n",j, p0->tAngles[swres->posd0[i]+j]/(float)DIVANGLE ,0.0, 0.0);
    
    fprintf(fich, "HEADER \n");
    longueur = swres->posf1[i] - swres->posd1[i] + 1;
    for(j=0; j< longueur ; j++)
      fprintf(fich, "ZZZ  %d %f %f %f \n",j, swres->prot1->tAngles[swres->posd1[i]+j]/(float)DIVANGLE ,0.0, 0.0); 
    
  }
  
}
