
#define LONGUEUR_STAT  200  /*longueur maximale etudiee pour stats sur les resultats*/
#define NB_GROUPE_MAX  10   /*nombre de groupe maximal spatialement compatibles pris pour les stats*/
#define ORDRE_MARKOV  8    /*ordre de markov choisi pour le calcul des MTD*/

/*structure pour additionner tous les resultats pour 1 prot contre 1 banque*/
typedef struct SommeRes {

  int n; /*nombre de resultats*/
  double s; /*somme des scores*/ 
  double r; /*somme des rms*/
  double m0;/*somme des MTD p0*/
  double m1;/*somme des MTD p1*/

} SommeRes;



int Set_TableFreq(char * nomFi);
void Free_TableFreq(void);
void  Free_MtdModel(void);

int CalculToutesProbasIndepBi(tyProt *pQuery, tyParametres *pParms);

int CalculProbaMtd(SWResult *swres, tyProt *p0);
int CalculProbaSimple(SWResult *swres, tyProt *p0);

int CalculToutesProbasMTD(SWResult *swres, tyProt *pQuery);


int ReadMTDModel(char *fname);
int CalculMtdProba(SWResult *swres, tyProt *p0);

double CalculProbaCompatibles(double *tProba, int *tCompatibles, int nbSHSP, int *num1erSHSPMeilleurGp);

void OutputComptages(SWResult *swres, tyProt *p0, int **tproba_simple, int ****tpar_paire, int option);
void FreeTransitions ( int **tproba_simple,  int ****tpar_paire);

void affichage_proba(int **tproba_simple,  int ****tpar_paire, FILE *sortie); 

void AddSommeRes (SommeRes **smres, SWResult *swres);
void AddGroupes (SommeRes ***smres, SWResult *swres);
void PrintSommeRes (SommeRes **smres);
SommeRes *NewSommeRes(void);
void FreeSommeRes (SommeRes **smres, SommeRes ***Groupes);
void augmente_p (int *p);
void  calcul_mtd (SWResult *swres, FILE *fich, tyProt *p0);
