/* swalign.c ABI:  April 2004   */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "swelfe.h"
#include "swalign.h"
#include "lecture.h"
#include "util.h"
#include "libabiutils.h"
#include "stats_sequence.h"
#include "score_struct.h"
#include "macros.h"
#include "kontrol.proto.h"  /*pour controler la memoire*/
#include "fonctions_main.h"
#include "ScBlosAngle.h"
#include "angles.h"

/*#define MEMOIRE 1*/


typedef int tab2int[2];

static Matrix   *sAliMat=NULL;
/* inclusion math.h #define round(x) (int)((x)>0?(x)+0.5:(x)-0.5) */


/* prototypes   */
static int sCompar(tab2int *x, tab2int *y);

/* -------------------------------------------------------------------  */

/* ---------------------------------------------------- */
/* New SWResult structure               */
/* ---------------------------------------------------- */
SWResult *NewSWResult(tyProt *p)
{
    SWResult *swres = NULL;

    NEWY(swres,  SWResult, 1);

    NEWY(swres->posd0,  int, NBRESULTS);
    NEWY(swres->posd1,  int, NBRESULTS);
    NEWY(swres->posf0,  int, NBRESULTS);
    NEWY(swres->posf1,  int, NBRESULTS);
    NEWY(swres->score,  float, NBRESULTS);
    NEWY(swres->score_freq,  double, NBRESULTS);
    NEWY(swres->score_par_freq,  double, NBRESULTS);
    NEWY(swres->score_GL,  double, NBRESULTS);
    NEWY(swres->tm_score,  double, NBRESULTS);
    NEWY(swres->score_blosangle,  float, NBRESULTS);
    NEWY(swres->recover,  float, NBRESULTS);
    NEWY(swres->rms,  double, NBRESULTS);
    NEWY(swres->rev_rms,  float, NBRESULTS);
    NEWY(swres->sali,  char *, NBRESULTS);
    NEWY(swres->tProbaMTD_p0,  double, NBRESULTS);
    NEWY(swres->tProbaMTD_p1,  double, NBRESULTS);
    NEWY(swres->tProbaIndep,  double, NBRESULTS);
    NEWY(swres->tProbaBi,  double, NBRESULTS);
    NEWY(swres->alpha,  float, NBRESULTS);
    NEWY(swres->beta,  float, NBRESULTS);
    NEWY(swres->gamma,  float, NBRESULTS);
    NEWY(swres->new_rms,  double, NBRESULTS);
    NEWY(swres->matrix4x,  DtMatrix4x4 , NBRESULTS);

    swres->nmatch = 0;
    swres->score[0] = -1.0;
    swres->score_freq[0] = -1.0;
    swres->score_par_freq[0] = -1.0;
    swres->score_GL[0] = -1.0;
    swres->score_blosangle[0] = -1.0;
    swres->tm_score[0] = -1.0;
    swres->realsize = NBRESULTS;
    swres->prot1 = p;
    swres->crossrms = NULL;
    swres->group = NULL;
    swres->sumLogProbaIndep =0.0;
    swres->sumLogProbaBi=0.0;
    swres->sumLogProbaMTD_p0=0.0;
    swres->sumLogProbaMTD_p1=0.0;
    swres->alpha[0]=0.0;
    swres->beta[0]=0.0;
    swres->gamma[0]=0.0;
    swres->new_rms[0]=0.0;
    return swres;
}

/* ---------------------------------------------------- */
/* Add a result                     */
/* ---------------------------------------------------- */
void AddSWResult(SWResult *swres, float score, double rms, float rev_rms,
                 float recover, int posd0, int posd1,
                 int posf0, int posf1, char *salign, DtMatrix4x4 matrix4x, double score_GL,
                 float score_blosangle, double tm_score, float alpha, float beta, float gamma, double new_rms)
{

    if (swres->nmatch >= swres->realsize) {
        TREALLOC(int,swres->posd0, swres->realsize+NBRESULTS);
        TREALLOC(int,swres->posd1, swres->realsize+NBRESULTS);
        TREALLOC(int,swres->posf0, swres->realsize+NBRESULTS);
        TREALLOC(int,swres->posf1, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->score, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->score_freq, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->score_par_freq, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->score_GL, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->tm_score, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->score_blosangle, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->recover, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->rms, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->rev_rms, swres->realsize+NBRESULTS);
        TREALLOC(char *,swres->sali, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->tProbaMTD_p0, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->tProbaMTD_p1, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->tProbaIndep, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->tProbaBi, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->alpha, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->beta, swres->realsize+NBRESULTS);
        TREALLOC(float,swres->gamma, swres->realsize+NBRESULTS);
        TREALLOC(double,swres->new_rms, swres->realsize+NBRESULTS);
        TREALLOC(DtMatrix4x4 ,swres->matrix4x, swres->realsize+NBRESULTS);

        swres->realsize += NBRESULTS;
    }

    swres->posd0[swres->nmatch] = posd0;
    swres->posd1[swres->nmatch] = posd1;
    swres->posf0[swres->nmatch] = posf0;
    swres->posf1[swres->nmatch] = posf1;
    swres->score[swres->nmatch] = score;
    swres->score_GL[swres->nmatch] = score_GL;
    swres->tm_score[swres->nmatch] = tm_score;
    swres->score_blosangle[swres->nmatch] = score_blosangle;
    swres->recover[swres->nmatch] = recover;
    swres->rms[swres->nmatch] = rms;
    swres->rev_rms[swres->nmatch] = rev_rms;
    swres->alpha[swres->nmatch] = alpha;
    swres->beta[swres->nmatch] = beta;
    swres->gamma[swres->nmatch] = gamma;
    swres->new_rms[swres->nmatch] = new_rms;

    NEWY(swres->sali[swres->nmatch],  char , strlen(salign)+1);
    swres->sali[swres->nmatch] = strcpy(swres->sali[swres->nmatch] , salign);

    if (matrix4x != NULL)
        memmove(swres->matrix4x[swres->nmatch], matrix4x, sizeof(DtMatrix4x4));
    swres->tProbaMTD_p0[swres->nmatch]=  0.0;
    swres->tProbaMTD_p1[swres->nmatch]=  0.0;
    swres->tProbaIndep[swres->nmatch]= 0.0;
    swres->tProbaBi[swres->nmatch]= 0.0;

    swres->nmatch++;

    return;
}

/* ---------------------------------------------------- */
/* free a SWResult structure                */
/* ---------------------------------------------------- */
void FreeSWResult(SWResult *swres, int freeprot)  /*attention si modifi, modifier aussi reinitialise dans stats_sequence.c*/
{
    int i;

    /*  fprintf(stderr,"size %d \n", swres->realsize);*/

    for (i=0; i < swres->nmatch; i++) {
        MYFREE(swres->sali[i]);
    }
    MYFREE(swres->sali);
    MYFREE(swres->matrix4x);

    if (swres->crossrms)
        for (i=0; i < swres->nmatch; i++)
            MYFREE(swres->crossrms[i]);
    MYFREE(swres->crossrms);

    if (swres->group)
        MYFREE(swres->group);

    if (swres ==NULL )
        fprintf(stderr,"MYFREE null \n");


    MYFREE(swres->posd0); 
    MYFREE(swres->posd1);
    MYFREE(swres->posf0);
    MYFREE(swres->posf1);
    MYFREE(swres->score);
    MYFREE(swres->score_freq);
    MYFREE(swres->score_par_freq);
    MYFREE(swres->score_GL);
    MYFREE(swres->tm_score);
    MYFREE(swres->score_blosangle);
    MYFREE(swres->recover);
    MYFREE(swres->rms);
    MYFREE(swres->rev_rms);
    MYFREE(swres->tProbaMTD_p0);
    MYFREE(swres->tProbaMTD_p1);
    MYFREE(swres->tProbaIndep);
    MYFREE(swres->tProbaBi);
    MYFREE(swres->alpha);
    MYFREE(swres->beta);
    MYFREE(swres->gamma);
    MYFREE(swres->new_rms);
    if (freeprot == FREEPROT) {
       FreeProt(swres->prot1);
       swres->prot1 = NULL;
    }
    MYFREE(swres);

    return;
}

/*--------------------------------------------- */
/* Print the fragment of seq of p at pos "pos"  */
/*  along the alignment string sali     */
/*--------------------------------------------- */
void PrintAliSeq(FILE *fout, tyProt *p, int pos, char *sali, char inser)
{
    char *ss = p->tNameRes + pos;

    fprintf(fout,"%s%-6c: ", p->nomProt,p->tFrag->name );
    while (*sali) {
        if (*sali == SUBST) {
            fputc((int)(*ss), fout);
            ss++;
        }
        else if (*sali == inser) {
            fputc((int)(*ss), fout);
            ss++;
        }
        else { /* delet */
            fputc((int)'-', fout);
        }
        sali++;
    }
    fputc((int)'\n', fout);
    return;

}

/*--------------------------------------------- */
/* return an "Id" character, i.e. '|' when  */
/* c1 == c2, or similarity ":" or "."       */
/*--------------------------------------------- */
static char IdChar(char c1, char c2, int *score_blosum)
{
    /* BLOSUM62 matrix    */
    static int mat[24][24]=
    {{4,-1,-2,-2,0,-1,-1,0,-2,-1,-1,-1,-1,-2,-1,1,0,-3,-2,0,-2,-1,0,-4},
        {-1,5,0,-2,-3,1,0,-2,0,-3,-2,2,-1,-3,-2,-1,-1,-3,-2,-3,-1,0,-1,-4},
        {-2,0,6,1,-3,0,0,0,1,-3,-3,0,-2,-3,-2,1,0,-4,-2,-3,3,0,-1,-4},
        {-2,-2,1,6,-3,0,2,-1,-1,-3,-4,-1,-3,-3,-1,0,-1,-4,-3,-3,4,1,-1,-4},
        {0,-3,-3,-3,9,-3,-4,-3,-3,-1,-1,-3,-1,-2,-3,-1,-1,-2,-2,-1,-3,-3,-2,-4},
        {-1,1,0,0,-3,5,2,-2,0,-3,-2,1,0,-3,-1,0,-1,-2,-1,-2,0,3,-1,-4},
        {-1,0,0,2,-4,2,5,-2,0,-3,-3,1,-2,-3,-1,0,-1,-3,-2,-2,1,4,-1,-4},
        {0,-2,0,-1,-3,-2,-2,6,-2,-4,-4,-2,-3,-3,-2,0,-2,-2,-3,-3,-1,-2,-1,-4},
        {-2,0,1,-1,-3,0,0,-2,8,-3,-3,-1,-2,-1,-2,-1,-2,-2,2,-3,0,0,-1,-4},
        {-1,-3,-3,-3,-1,-3,-3,-4,-3,4,2,-3,1,0,-3,-2,-1,-3,-1,3,-3,-3,-1,-4},
        {-1,-2,-3,-4,-1,-2,-3,-4,-3,2,4,-2,2,0,-3,-2,-1,-2,-1,1,-4,-3,-1,-4},
        {-1,2,0,-1,-3,1,1,-2,-1,-3,-2,5,-1,-3,-1,0,-1,-3,-2,-2,0,1,-1,-4},
        {-1,-1,-2,-3,-1,0,-2,-3,-2,1,2,-1,5,0,-2,-1,-1,-1,-1,1,-3,-1,-1,-4},
        {-2,-3,-3,-3,-2,-3,-3,-3,-1,0,0,-3,0,6,-4,-2,-2,1,3,-1,-3,-3,-1,-4},
        {-1,-2,-2,-1,-3,-1,-1,-2,-2,-3,-3,-1,-2,-4,7,-1,-1,-4,-3,-2,-2,-1,-2,-4},
        {1,-1,1,0,-1,0,0,0,-1,-2,-2,0,-1,-2,-1,4,1,-3,-2,-2,0,0,0,-4},
        {0,-1,0,-1,-1,-1,-1,-2,-2,-1,-1,-1,-1,-2,-1,1,5,-2,-2,0,-1,-1,0,-4},
        {-3,-3,-4,-4,-2,-2,-3,-2,-2,-3,-2,-3,-1,1,-4,-3,-2,11,2,-3,-4,-3,-2,-4},
        {-2,-2,-2,-3,-2,-1,-2,-3,2,-1,-1,-2,-1,3,-3,-2,-2,2,7,-1,-3,-2,-1,-4},
        {0,-3,-3,-3,-1,-2,-2,-3,-3,3,1,-2,1,-1,-2,-2,0,-3,-1,4,-3,-2,-1,-4},
        {-2,-1,3,4,-3,0,1,-1,0,-3,-4,0,-3,-3,-2,0,-1,-4,-3,-3,4,1,-1,-4},
        {-1,0,0,1,-3,3,4,-2,0,-3,-3,1,-1,-3,-1,0,-1,-3,-2,-2,1,4,-1,-4},
        {0,-1,-1,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2,0,0,-2,-1,-1,-1,-1,-1,-4},
        {-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,1}
    };
    /* index of c-'A' in BLOSUM62 matrix  */
    /* A  R  N  D  C  Q  E  G  H  I  L  K  M  F  P  S  T  W  Y  V  B  Z  X  * */
    /* 0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 */
    /* indx contient les index de lalphabet de 'A' a 'Z' dans mat */
    static int indx[26]={0,20,4,3,6,13,7,8,9,23,11,10,12,2,23,14,5,1,15,16,23,19,17,22,18,21};

    *score_blosum += mat[indx[(int)(c1-'A')]][indx[(int)(c2-'A')]];

    if (mat[indx[(int)(c1-'A')]][indx[(int)(c2-'A')]] >= 4)
        return '|';
    else if (mat[indx[(int)(c1-'A')]][indx[(int)(c2-'A')]] >= 2)
        return ':';
    else if (mat[indx[(int)(c1-'A')]][indx[(int)(c2-'A')]] >= 1)
        return '.';
    else
        return ' ';

}

/*affiche la longueur des matchs exacts (pos sans gaps)*/
void Print_lg_matchs(FILE *fout, char *sali) {

    int lg1=0, lg2=0;


    while (*sali) {
        if (*sali == SUBST) {
            lg1++;
            lg2++;
        }
        else if (*sali == INSER) {
            lg1 ++;
        }
        else {
            lg2 ++;
        }
        sali++;
    }

    fprintf(fout,"%6d %6d ", lg1, lg2);

    return;
}



/*--------------------------------------------- */
/* calculate the "Id" alignment string      */
/*  along the alignment string sali     */
/*--------------------------------------------- */
void CalculIdAli(tyProt *p1, int posd1,
                 tyProt *p2, int posd2, char *sali, int *score_blosum)
{
    char     *ss1 = p1->tNameRes + posd1,
                    *ss2 = p2->tNameRes + posd2,
                           c;


    while (*sali) {

        if (*sali == SUBST) {
            c = IdChar(*ss1,*ss2, score_blosum);

            ss1++;
            ss2++;
        }
        else if (*sali == INSER) {
            *score_blosum -= 10;
            ss1++;
        }
        else { /* delet */
            *score_blosum -= 10;
            ss2++;
        }
        sali++;
    }
    return;

}

/*--------------------------------------------- */
/* Print the "Id" alignment string      */
/*  along the alignment string sali     */
/*--------------------------------------------- */
void PrintIdAli(FILE *fout, tyProt *p1, int posd1,
                tyProt *p2, int posd2, char *sali, int *score_blosum, int SPN)
{
    char     *ss1 = p1->tNameRes + posd1,
                    *ss2 = p2->tNameRes + posd2,
                           c;
    int i;

    fprintf(fout, "        ");
    for (i=0; i<strlen(p1->nomProt); i++)
        fprintf(fout," ");

    while (*sali) {
        if (*sali == SUBST) {
            c = IdChar(*ss1,*ss2, score_blosum);
            fputc((int)(c), fout);
            ss1++;
            ss2++;
        }
        else if (*sali == INSER) {
            fputc((int)' ', fout);
            *score_blosum -= 10;
            ss1++;
        }
        else { /* delet */
            fputc((int)' ', fout);
            *score_blosum -= 10;
            ss2++;
        }
        sali++;
    }
    fputc((int)'\n', fout);
    return;

}
/*affiche les angles alignes */
void PrintAngles (FILE *fout, SWResult *swres, tyProt *p0, int i, int output) {

    int longueur, position, j;

    longueur = (int)strlen(swres->sali[i]);
    position = 0;


    if (output == 0)
        fprintf(fout,"%s%-6c: ", p0->nomProt,p0->tFrag->name );
    for (j=0; j< longueur ; j++) {
        if (swres->sali[i][j] == SUBST || swres->sali[i][j] == INSER) {
            fprintf(fout, "%7.1f", p0->tAngles[swres->posd0[i]+position]/(float)DIVANGLE);
            position ++;
        }
        else
            fprintf(fout, "   -   ");
    }
    fprintf(fout, " \n");

    if (output == 1)
        fprintf(fout, "##3  ");

    if (output == 0)
        fprintf(fout,"%s%-6c: ", swres->prot1->nomProt,swres->prot1->tFrag->name );
    position = 0;
    for (j=0; j< longueur  ; j++) {
        if (swres->sali[i][j] == SUBST || swres->sali[i][j] == DELET) {
            fprintf(fout, "%7.1f", (swres->prot1->tAngles[swres->posd1[i]+position])/(float)DIVANGLE);
            position ++;
        }
        else
            fprintf(fout, "   -   ");
    }
    fprintf(fout, " \n");

}
/*affiche les angles alignes */
void PrintAnglesRecodes (FILE *fout, SWResult *swres, tyProt *p0, int i, int output) {

    int longueur, position, j;

    longueur = (int)strlen(swres->sali[i]);
    position = 0;


    if (output == 0)
        fprintf(fout,"%s%-6c: ", p0->nomProt,p0->tFrag->name );
    for (j=0; j< longueur ; j++) {
        if (swres->sali[i][j] == SUBST || swres->sali[i][j] == INSER) {
            fprintf(fout, "%4d", p0->tAnglesRecodes[swres->posd0[i]+position]);
            position ++;
        }
        else
            fprintf(fout, " -  ");
    }
    fprintf(fout, " \n");

    if (output == 1)
        fprintf(fout, "##3  ");

    if (output == 0)
        fprintf(fout,"%s%-6c: ", swres->prot1->nomProt,swres->prot1->tFrag->name );
    position = 0;
    for (j=0; j< longueur  ; j++) {
        if (swres->sali[i][j] == SUBST || swres->sali[i][j] == DELET) {
            fprintf(fout, "%4d", (swres->prot1->tAnglesRecodes[swres->posd1[i]+position]));
            position ++;
        }
        else
            fprintf(fout, " -  ");
    }
    fprintf(fout, " \n");

}


/*--------------------------------------------- */
/* print result of SW run           */
/*--------------------------------------------- */
void PrintResult(FILE *fout, SWResult *swres, tyProt *p0, int proba, int SPN, float moyenne, float ecart_type)
{
    int i,j, score_blosum;
    /*  float score_blosum_angle;*/

    if (swres->nbprint > 0) {


        fprintf(fout,"---- p0= %s%c p1= %s%c RESULTS ----\n", p0->nomProt, p0->tFrag->name, swres->prot1->nomProt, swres->prot1->tFrag->name );
        for (i = 0; i < swres->nbprint; i++) {
            score_blosum=0;
            fprintf(fout,"*********************************************************\n");
            fprintf(fout,"Number %4d local alignment\n",i+1);
            fprintf(fout,"Begins at (%d,%d) ", swres->posd0[i],swres->posd1[i]);
            if (SPN==STRUCTURE)
              fprintf(fout, "[PDB=(%4d%c,%4d%c)] ",
                    (int)(p0->tNumPDB[swres->posd0[i]].num[1]), p0->tNumPDB[swres->posd0[i]].inser[0],
                    (int)((swres->prot1)->tNumPDB[swres->posd1[i]].num[1]), (swres->prot1)->tNumPDB[swres->posd1[i]].inser[0]);
            fprintf(fout,"Ends at (%d,%d) ", swres->posf0[i],swres->posf1[i]);
            if (SPN==STRUCTURE)
              fprintf(fout, "[PDB=(%4d%c,%4d%c)] ",
                    (int)(p0->tNumPDB[swres->posf0[i]].num[1]), p0->tNumPDB[swres->posf0[i]].inser[0],
                    (int)((swres->prot1)->tNumPDB[swres->posf1[i]].num[1]), (swres->prot1)->tNumPDB[swres->posf1[i]].inser[0]);
            fprintf(fout,"\n");
            fprintf(fout, "Length protein1 %4d protein2 %4d\n", p0->nbRes, (swres->prot1)->nbRes);
            fprintf(fout,"Score %10.2f  Score/Alignement Length %8.3f\n",
                    swres->score[i],
                    swres->score[i]/(float)((int)strlen(swres->sali[i])));
            fprintf(fout, "RMS or Probability %7.2f Overlap %4.2f Alignment length %4d ",
                    swres->rms[i], swres->recover[i], (int)strlen(swres->sali[i]));
#ifdef ADVANCED
            fprintf(fout, " Reverse RMS %7.2f\n", swres->rev_rms[i]);
#endif
            fprintf(fout, "\n");

            if (proba == 1)
                fprintf(fout,"MTD Probability protein1 %4.3f protein2 %4.3f \n\n",swres->tProbaMTD_p0[i] ,swres->tProbaMTD_p1[i]);


            if (SPN == NUCLEIQUE || SPN == PROTEIQUE) {
                fprintf(fout,"Zscore %.3f\n",(swres->score[i]-moyenne)/ecart_type );
            }
            else { /* (SPN == STRUCTURE) */
                /*score blosum calcule dans PrintIdAli, selon la matrice de blosum62, et moins 10 pour les gaps*/
                /*  CalculBlosumAngles(p0, swres->posd0[i], swres->prot1, swres->posd1[i], swres->sali[i], &score_blosum_angle);*/
                fprintf(fout,"Blosum score: %5d GL score : %5.2f Group : %1d Score_freq :  %20.2f Blosum_angle : %5.3f TM score %5.3f\n",
                      score_blosum, swres->score_GL[i],swres->group[i],swres->score_freq[i],
                      swres->score_blosangle[i], swres->tm_score[i]);
#ifdef GSL
                fprintf(fout,"Rotation angles: alpha %.2f beta %.2f gamma %.2f ", swres->alpha[i],swres->beta[i],swres->gamma[i]);
#endif
                fprintf(fout,"  RRMSD: %.2f\n", swres->new_rms[i]);
            } /*fin SPN == STRUCT*/

#if 0       /* si on veut la chaine d'alignement    */
            fprintf(fout,"Alignment string     : %s\n",swres->sali[i]);
#endif
            if (SPN == STRUCTURE)
               fprintf(fout,"Sequence alignment corresponding to structure match:\n");
            else
               fprintf(fout,"Sequence alignment:\n");
            PrintAliSeq(fout, p0, swres->posd0[i], swres->sali[i], INSER);
            PrintIdAli(fout, p0, swres->posd0[i], (swres->prot1), swres->posd1[i], swres->sali[i], &score_blosum, SPN);
            PrintAliSeq(fout, (swres->prot1), swres->posd1[i], swres->sali[i], DELET);

            if (SPN == STRUCTURE) {
                /*angles vrais*/
                fprintf(fout,"Angle alignment:\n");
                PrintAngles (fout, swres, p0, i,0) ;
            }

        }/*fin for i*/

        if (SPN == STRUCTURE) {
            /* print crossed RMS      */

            /* entete             */
            fprintf(fout,"\nNUM   GROUP ");
            for (j = 0; j < swres->nmatch; j++)
                fprintf(fout,"%7d ",j+1);
            fprintf(fout,"\n");

            /* print table            */
            for (i = 0; i < swres->nmatch; i++) {
                fprintf(fout,"%5d [%3d] ",i+1,swres->group[i]);
                for (j = 0; j < swres->nmatch; j++) {
                    fprintf(fout,"%7.2f ",swres->crossrms[i][j]);
                }
                fprintf(fout,"\n");
            }
            /* affichage somme log proba MTD*/
            if (proba == 1)
                fprintf(fout,"Sum Log MTD Probability protein1 %6.5f protein2 %6.5f\n ", swres->sumLogProbaMTD_p0 , swres->sumLogProbaMTD_p1);
        } /*fin SPN == STRUCT*/

        fprintf(fout,"\n\n");

    }
    return;
}

/*--------------------------------------------- */
/* print result of SW run   : short print       */
/*--------------------------------------------- */
void PrintResult2(FILE *fout, SWResult *swres, tyProt *p0, int proba, int SPN, float moyenne, float ecart_type, float *mat_or_thresh, float gap_o, float gap_e)
{
    int i, score_blosum;
    /*  float score_blosum_angle;*/


    if (swres->nbprint > 0) {
        fprintf(fout,"@p0         p1          #repeat start0 start1 lg_prot    score   rms/proba overlap ");
#ifdef ADVANCED
        fprintf(fout,"rev_rms ");
#endif
        fprintf(fout,"lg_match match1 match2 ");
        if (SPN == STRUCTURE) {
            fprintf(fout," blosum GLscore compat start0 start1 end0 end1 ");
#ifdef GSL
            fprintf(fout," alpha   beta  gamma   RRMSD");
#else
            fprintf(fout,"  RRMSD");
#endif
        }
        fprintf(fout,"\n");
        /* calcule_score_freq (swres, p0, mat_or_thresh, gap_o, gap_e);*/  /*fonction commentee !! */
        /*  calcule_score_par_freq (swres, p0, mat_or_thresh, gap_o, gap_e);*/

        for (i = 0; i < swres->nbprint; i++) {
            score_blosum=0;
            CalculIdAli( p0, swres->posd0[i], (swres->prot1), swres->posd1[i], swres->sali[i], &score_blosum);
            /*noms*/
            fprintf(fout,"%10s%c %10s%c ",p0->nomProt, p0->tFrag->name, swres->prot1->nomProt, swres->prot1->tFrag->name);
            /*nom, pos*/
            fprintf(fout," %6d %6d %6d %7d ",i+1, swres->posd0[i], swres->posd1[i], p0->nbRes);
/*            fprintf(fout," %6d %6d %6d %7d %7d ",i+1, swres->posd0[i], swres->posd1[i], p0->nbRes, swres->prot1->nbRes);*/
            /*scores */
            fprintf(fout,"%8.2f ",swres->score[i]);
            if (SPN == STRUCTURE)
                fprintf(fout,"%11.2f ", swres->rms[i]);
            else
                fprintf(fout," %11.2f ", 1 - swres->rms[i]);
            /* rms*/
            fprintf(fout,"%7.2f ", swres->recover[i]);
#ifdef ADVANCED
            fprintf(fout,"%7.2f ",swres->rev_rms[i]);
#endif
            fprintf(fout,"%8d ",  (int)strlen(swres->sali[i]) );
            /*   fprintf(stderr," rms ok %.3f    \n", swres->rms[i]);*/
            Print_lg_matchs(fout, swres->sali[i]);
            if (SPN != STRUCTURE) {
#if 0            
                if ( ecart_type < 0.000001 ) { /* zscore*/
                    fprintf(fout," %.3f \n",(swres->score[i]-moyenne)/ecart_type );
                }
#endif                 
                fprintf(fout,"\n" );
                fprintf(fout,"#1  ");
                PrintAliSeq(fout, p0, swres->posd0[i], swres->sali[i], INSER);
                fprintf(fout,"#2  ");
                PrintIdAli(fout, p0, swres->posd0[i], (swres->prot1), swres->posd1[i], swres->sali[i], &score_blosum, SPN);
                fprintf(fout,"#3  ");
                PrintAliSeq(fout, (swres->prot1), swres->posd1[i], swres->sali[i], DELET);
            }
            else {
                /*    CalculBlosumAngles(p0, swres->posd0[i], swres->prot1, swres->posd1[i], swres->sali[i], &score_blosum_angle);*/
                /* */
                fprintf(fout," %6d %7.2f %6d ",score_blosum, swres->score_GL[i],swres->group[i]);
                fprintf(fout,"  %4d   %4d %4d %4d ",(int)(p0->tNumPDB[swres->posd0[i]].num[1]), (int)(swres->prot1->tNumPDB[swres->posd1[i]].num[1]),(int)(p0->tNumPDB[swres->posf0[i]].num[1]), (int)(swres->prot1->tNumPDB[swres->posf1[i]].num[1]));
#ifdef GSL
                fprintf(fout," %6.2f %6.2f %6.2f ",swres->alpha[i],swres->beta[i],swres->gamma[i]);
#endif
                fprintf(fout," %6.2f\n",swres->new_rms[i]);

                /* angles */ /*noms*/
                fprintf(fout,"##1 %s%c %s%c %4d   \n",p0->nomProt, p0->tFrag->name, swres->prot1->nomProt, swres->prot1->tFrag->name, (int)strlen(swres->sali[i]));
                fprintf(fout,"##2  ");
                PrintAngles (fout, swres, p0, i,1) ;
                fprintf(fout,"==1  ");
                PrintAliSeq(fout, p0, swres->posd0[i], swres->sali[i], INSER);
                fprintf(fout,"==2  ");
                PrintAliSeq(fout, (swres->prot1), swres->posd1[i], swres->sali[i], DELET);


            }  /*SPN == 0*/

        }/*fin for i*/
    }

}

/*********************************************************************/
/* Fonction de comparaison pour qsort*/
/* classe en ordre decroissant         */
/*********************************************************************/
static int sCompar(tab2int *x, tab2int *y)
{
    return( ((*x)[1] < (*y)[1]) ? 1 : ((*x)[1] > (*y)[1] ? -1 : 0));
} /* end of int sCompar(x, y) */

/*********************************************************************/
/* Fonction de comparaison pour qsort*/
/* classe en ordre croissant         */
/*********************************************************************/
static int sCompar2(tab2int *x, tab2int *y)
{
    return( ((*x)[1] > (*y)[1]) ? 1 : ((*x)[1] < (*y)[1] ? -1 : 0));
} /* end of int sCompar2(x, y) */

#ifndef MAX
#define MAX( a , b ) ( ( a ) > ( b ) ? ( a ) : ( b ) )
#endif

/*--------------------------------------------- */
/* make RMS compatible groups           */
/*--------------------------------------------- */
void makegroup(int premier, int dernier, float **crossrms, int *group, int *ngroup, float cross_rms_seuil)
{
    int       i, j, k, gj;
    float maxrms;
    tab2int *tt;

    *ngroup = 0;

    for (i = premier; i < dernier; i++)
        group[i] = -1;

    for (i = premier; i < dernier; i++) {
        if (group[i] == -1) {
            group[i] = (*ngroup)++;
#if 0
            fprintf(stderr,"[0] i=%d groupe=%d\n",i,group[i]);
#endif
        }
#if 0
        fprintf(stderr,"[0 bis] i=%d groupe=%d\n",i,group[i]);
#endif

        for (j = i+1; j < dernier; j++) {
            /*       printf("%10.2f %10.2f\n",crossrms[j][i],crossrms[i][j]);*/

            maxrms = MAX(crossrms[j][i],crossrms[i][j]);
            if (maxrms < cross_rms_seuil) {
                if (group[j] != -1) {
                    gj = group[j]; /* pour ne pas ecraser j */
                    for (k = premier; k < dernier; k++) {
                        if (group[k] == gj) {
                            group[k] = group[i];
#if 0
                            fprintf(stderr,"[3] k=%d groupe=%d\n",k,group[k]);
#endif
                        }
                    }
                }
                else {
                    group[j] = group[i];
#if 0
                    fprintf(stderr,"[2] j=%d groupe=%d\n",j,group[j]);
#endif
                }
            }
        }
    }

    /*pour remettre les groupes dans l'ordre, trie en fontion de leur nombre d'individus*/

    tt = NEWN(tab2int, dernier);
    for (i=0;i<dernier;i++)
        tt[i][0] = tt[i][1] = 0;

    for (i=0;i<dernier;i++) {
        tt[group[i]][0]=group[i];
        tt[group[i]][1]++;
    }
    /*tri en fonction du nombre d'individus*/
    qsort(tt,*ngroup,sizeof(tab2int), (int (*)(const void * , const void * ))sCompar);

    for (i=0;i<*ngroup;i++) {
        tt[i][1]= tt[i][0];
        tt[i][0]=i;
    }
    /*tri croissant en fonction de l'indice du tableau*/
    qsort(tt,*ngroup,sizeof(tab2int), (int (*)(const void * , const void * ))sCompar2);


    for (i=0; i< dernier; i++) {
        group[i] = tt[group[i]][0];
    }

    MYFREE(tt);

    return;
}

/* ---------------------------------------------------- */
static Matrix *NewMatrix(int n1, int n2)
{
    Matrix *m = NEW(Matrix);
    /*  int i;*/
    if (! m)
        return NULL;

    m->rsize = n1*n2;
    m->n1 = n1;
    m->n2 = n2;

    m->f = NEWN(float, n1*n2);
    m->c = NEWN(char, n1*n2);
    if (!(m->f) || !(m->c))  {
        free(m);
        return NULL;
    }
#if 0
    for (i=0 ; i<n1*n2; i++) {
        m->f[i] = -1;
        m->c[i] = '\0';
    }
#endif
    memset((void *)(m->f), 0, sizeof(*(m->f))*(size_t)(m->rsize));
    memset((void *)(m->c), (int)ZERO, sizeof(*(m->c))*(size_t)(m->rsize));

    return m;

}
/* ---------------------------------------------------- */
void FreeMatrix(void)
{
    if (sAliMat) {
        MYFREE(sAliMat->f);
        MYFREE(sAliMat->c);
        MYFREE(sAliMat);
    }
}

/* ---------------------------------------------------- */
static Matrix *ReNewMatrix(Matrix *m, int n1, int n2)
{

    /*   int i;*/
    if (! m) {
        if (!(m = NewMatrix(n1,n2)))
            return NULL;
        else
            return m;
    }

    m->rsize = n1*n2;
    m->n1 = n1;
    m->n2 = n2;

    free(m->f);
    free(m->c);
    m->f = NEWN(float, n1*n2);
    m->c = NEWN(char, n1*n2);
    if (!(m->f) || !(m->c))  {
        free(m);
        return NULL;
    }
#if 0
    for (i=0 ; i<n1*n2; i++) {
        m->f[i] = -1;
        m->c[i] = '\0';
    }
#endif
    memset((void *)(m->f), 0, sizeof(*(m->f))*(size_t)(m->rsize));
    memset((void *)(m->c), (int)ZERO, sizeof(*(m->c))*(size_t)(m->rsize));
    return m;

}

/* ---------------------------------------------------- */
void sPrintMatrix(Matrix *m)
{
    float *f = m->f;
    char  *c = m->c;
    int   i,j;

    for (i = 0; i < m->n2; i++) {
        for (j = 0; j < m->n1; j++) {
            fprintf(stderr, " %6.1f",*f++);
        }
        fprintf(stderr,"\n");
    }

    fprintf(stderr,"\n");

    for (i = 0; i < m->n2; i++) {
        for (j = 0; j < m->n1; j++) {
            fprintf(stderr, "   %c",*c++);
        }
        fprintf(stderr,"\n");
    }

    return;
}


/*---------------------------------------*/
/* compute matrix for  nucleic acid pair */
/*---------------------------------------*/
void compute_nuc_matrix(pam_matrix *matrix, float *freq, float *gap) {

    int i, j, k, size;
    char    nuc[5] = "ACGT";
    float min, max;

    strcpy(matrix->name, "Nucleic");
    strcpy(matrix->vocab, PROT_ALPHABET);

    size = strlen(matrix->vocab);

    matrix->pathname[0] = '\000';

    matrix->type      = MAT_PAM_TYPE;
    matrix->size      = size;

    min = max = 0.0;

    for (i = 0 ; i < size ; i++) {
        for (j = i+1 ; j < size ; j++) {
            matrix->val[j][i]    = matrix->val[i][j]    = 0.0;
            matrix->classe[j][i] = matrix->classe[i][j] = 0;
            matrix->freq[j][i] = matrix->freq[i][j] = 0.0L;
        }
        matrix->val[i][i] = 0.0;
        matrix->classe[i][i] = 1;
        matrix->freq[i][i] = 0.0L;
        matrix->weight[i] = 1.0;
    }

    for (i = 0; i < 4; i++) {
        /* remplissage avec une indetermination */
        for (k = 0; k < size; k++) {
            matrix->freq[nuc[i]-'A'][k] =  matrix->freq[k][nuc[i]-'A'] = freq[i] * log10(freq[i]) / (log10(4.0));
            /*         fprintf(stderr,"==== min %f max %f mat %f i j %d %d \n", min, max,  matrix->freq[nuc[i]-'A'][k] , nuc[i]-'A', k );*/
        }
        /* remplissage des vrais nucleotides */
    }
    for (i = 0; i < 4; i++) {
        for (j = i+1; j < 4; j++) { /*subst*/
            matrix->freq[nuc[i]-'A'][nuc[j]-'A'] = matrix->freq[nuc[j]-'A'][nuc[i]-'A'] = 0.5 * log10(freq[i] * freq[j]) / (log10(4.0));
#ifdef N_SUBST
            matrix->freq[nuc[i]-'A'][nuc[j]-'A'] = matrix->freq[nuc[j]-'A'][nuc[i]-'A'] = N_SUBST;
#endif

            if (matrix->freq[nuc[i]-'A'][nuc[j]-'A'] > max )
                max  = matrix->freq[nuc[i]-'A'][nuc[j]-'A'];
            if (matrix->freq[nuc[i]-'A'][nuc[j]-'A'] < min )
                min  = matrix->freq[nuc[i]-'A'][nuc[j]-'A'];
            /*       fprintf(stderr,"*** min %f max %f mat %f i j %d %d \n", min, max,  matrix->freq[nuc[i]-'A'][nuc[j]-'A'] , nuc[i]-'A', nuc[j]-'A' );*/

        }
    }
    for (i = 0; i < 4; i++) { /*identite*/
        matrix->freq[nuc[i]-'A'][nuc[i]-'A'] = -0.5 * log10(freq[i] * freq[i]) / (log10(4.0));
#ifdef N_IDENT
        matrix->freq[nuc[i]-'A'][nuc[i]-'A'] = N_IDENT;
#endif
        if (matrix->freq[nuc[i]-'A'][nuc[i]-'A'] > max )
            max  = matrix->freq[nuc[i]-'A'][nuc[i]-'A'];
        if (matrix->freq[nuc[i]-'A'][nuc[i]-'A'] < min )
            min  = matrix->freq[nuc[i]-'A'][nuc[i]-'A'];
        /*  fprintf(stderr," ///min %f max %f mat %f, indice %d\n", min, max, matrix->freq[nuc[i]-'A'][nuc[i]-'A'],  nuc[i]-'A' );*/

    }

    /*  fprintf(stderr," identite : %f substitution %f\n", matrix->freq[nuc[1]-'A'][nuc[1]-'A'],matrix->freq[nuc[1]-'A'][nuc[2]-'A'] );*/


    /*    if (gap != NULL){
            *gap = -1*( max - (max - min)*DIFF_GAP);
            fprintf(stderr,"gap %f min %f max %f \n", *gap, min, max );
            }*/

    /*  for (i = 0 ; i < matrix->size ; i++) {
            for (j = 0 ; j < matrix->size ; j++)
                fprintf(stderr, "%4.2f   ", matrix->freq[i][j]);
           fprintf(stderr, "\n");
        }
    */

    /*valeurs faibles pour les Z : */

    for (k = 0; k < size; k++) {
        /* JOMPO, je suis passe de -50 a 0, pas de raison de penaliser Z */
        matrix->freq['Z'-'A'][k] = 0;
        matrix->freq[k]['Z'-'A'] = 0;
    }

}

/* ---------------------------------------------------- */
/* score for an nucleic acid pair               */
/* ---------------------------------------------------- */
float anuc_score(int a1, int a2, pam_matrix *mat)
{
    return SWADN_MULT*mat->freq[a1][a2];
}


/* ---------------------------------------------------- */
/* score for an aminoacid pair              */
/* ---------------------------------------------------- */
float aascore(int a1, int a2, pam_matrix *mat)
{
    return mat->val[a1][a2];
}

/* ---------------------------------------------------- */
/* score for an angle pair              */
/* ---------------------------------------------------- */
float anglescorenouveau(int a1, int a2, float *threshold)
{
    double t;
    double max_angle = 0.02371223;  /* frequence d'angle au maximum dans la PDB */
    double min_angle = 0.0003717822;  /*angle min*/
    double freqA, freqB;
    double beta = 0.4;
    if (a1 >= NOT_INT_ANGLE || a2 >= NOT_INT_ANGLE) {
        /* il faut couler le score  */
        /* OLD score = threshold - 180.0; */
        return -1000000000.0;
#ifdef DEBUGQ
        fprintf(stderr, "NOT_INT_ANGLE a1= %6.1f a2= %6.1f \n", (float)a1/DIVANGLE,(float)a2/DIVANGLE);
#endif
    }
    else {
        /*    fprintf(stderr, "threa %d \n",*threshold);*/
        freqA = 1 - ( AnglesAlpha[180+(int)(a1/DIVANGLE)] - min_angle)/(max_angle-min_angle) ;
        freqB = 1 - ( AnglesAlpha[180+(int)(a2/DIVANGLE)] - min_angle)/(max_angle-min_angle) ;

#if 0
fprintf(stderr, "%4d-%4d -> %f\n", a1, a2, round((  (t=ABS(a1-a2)) <= 1800) ?  (*threshold * (freqA * freqB * (1-beta) + beta)- (float)t/DIVANGLE) : (*threshold * (freqA * freqB * (1-beta) + beta) - 360.0 + (float)t/DIVANGLE)));
#endif

        return  (((t=ABS(a1-a2)) <= 1800) ?
                 (*threshold * (freqA * freqB * (1-beta) + beta)- (float)t/DIVANGLE) :
                 (*threshold * (freqA * freqB * (1-beta) + beta) - 360.0 + (float)t/DIVANGLE));

    }
}


/* ---------------------------------------------------- */
/* score for an nucleic acid pair               */
/* ---------------------------------------------------- */
int Ianuc_score(int a1, int a2, pam_matrix *mat)
{
    return (int)(round((double)ADN_MULT*mat->freq[a1][a2]));
}


/* ---------------------------------------------------- */
/* score for an aminoacid pair              */
/* ---------------------------------------------------- */
int Iaascore(int a1, int a2, pam_matrix *mat)
{
    return (int)(mat->val[a1][a2]);
}

/* ---------------------------------------------------- */
/* score for an angle pair              */
/* ---------------------------------------------------- */
int Ianglescorenouveau(int a1, int a2, float *threshold)
{
    double t;
    double max_angle = 0.02371223;  /* frequence d'angle au maximum dans la PDB */
    double min_angle = 0.0003717822;  /*angle min*/
    double freqA, freqB;
    double beta = 0.4;


    /* OLD score = threshold - 180.0; */
    if (a1 >= NOT_INT_ANGLE || a2 >= NOT_INT_ANGLE) {
        /* il faut couler le score  */
        /* fprintf(stderr, "NOT_INT_ANGLE a1= %6.1f a2= %6.1f \n", (float)a1/DIVANGLE,(float)a2/DIVANGLE); */
        return -1000000000;
    }
    else {
        /* fprintf(stderr, "threa %d \n",*threshold);*/
        freqA = 1 - ( AnglesAlpha[180+(int)(a1/DIVANGLE)] - min_angle)/(max_angle-min_angle) ;
        freqB = 1 - ( AnglesAlpha[180+(int)(a2/DIVANGLE)] - min_angle)/(max_angle-min_angle) ;

#if 0 /* for debug */
       fprintf(stderr, "%4d , %4d -> %4d\n", a1, a2, (int)(round((  (t=ABS(a1-a2)) <= 1800) ?  (*threshold * (freqA * freqB * (1-beta) + beta)- (float)t/DIVANGLE) : (*threshold * (freqA * freqB * (1-beta) + beta) - 360.0 + (float)t/DIVANGLE))));
        fflush(stderr);
#endif

        return  (int)(round((
                                (t=ABS(a1-a2)) <= 1800) ?
                            (*threshold * (freqA * freqB * (1-beta) + beta)- (float)t/DIVANGLE) :
                            (*threshold * (freqA * freqB * (1-beta) + beta) - 360.0 + (float)t/DIVANGLE)
                           ));
    }
}

/* ---------------------------------------------------- */
/* blosum angle : score for an angle pair               */
/* ---------------------------------------------------- */
float blosum_anglescore(int a1, int a2, float *threshold)
{
    /*ici les angles sont codes en classe !!!*/

    if (a1 >= NOT_INT_ANGLE || a2 >= NOT_INT_ANGLE) {
        /* il faut couler le score  */
        /* OLD score = threshold - 180.0; */
        return -1000000000.0;
    }
    else
        return ScBlosAngle[a1][a2];
}

/*---------------------------------------------     */
/* calcule le score avec la matrice blosum angles   */
/*---------------------------------------------     */
void CalculBlosumAngles(tyProt *p1, int posd1,
                        tyProt *p2, int posd2, char *sali, float *score_blosum_angle)
{
    /*plus mauvais score = score angles bizarres = -4*/

    int      *ss1 = p1->tAnglesRecodes + posd1,
                    *ss2 = p2->tAnglesRecodes + posd2;
    *score_blosum_angle=0;

    while (*sali) {
        if (*sali == SUBST) {
            *score_blosum_angle += ScBlosAngle[*ss1][*ss2];
            ss1++;
            ss2++;
        }
        else if (*sali == INSER) {
            *score_blosum_angle -= 5;
            ss1++;
        }
        else { /* delet */
            *score_blosum_angle -= 5;
            ss2++;
        }
        sali++;
    }
    return;

}

/*------------------------------------------------- */
/* retourne max de 5 float              */
/*------------------------------------------------- */
float maximum_5 (float a, float b, float c, float d, float e) {

    if ( a>=b && a>=c && a>=d && a>=e)
        return a;
    if (b >= c && b >= d &&  b >= e)
        return b;
    if (c >= d && c >= e)
        return c;
    if (d >= e)
        return d;
    return e;
}



/* ---------------------------------------------------- */
int MakeCoordFromAlign(COORDS *p0, COORDS *p1, char *sali,
                       COORDS **pp0, COORDS **pp1)
{
    int lenali = 0;
    /* allocate too much memory */
    /* i.e. for the gap     */
    NEWY(*pp0,COORDS, (size_t)strlen(sali));
    NEWY(*pp1, COORDS, (size_t)strlen(sali));
    if (!pp0 || !pp1)
        return -1;

    while (*sali) {
        switch (*sali) {
        case SUBST:
            (*pp0)[lenali] = (*p0);
            p0++;
            (*pp1)[lenali] = (*p1);
            p1++;
            lenali++;
            break;
        case INSER:      /* forward on p0    */
            p0++;
            break;
        case DELET:      /* forward on p1    */
            p1++;
            break;
        }
        sali++;
    }

    return lenali;
}



/* ---------------------------------------------------- */
/* Swalign main routine                 */
/* ---------------------------------------------------- */
SWResult *swalign(tyProt *p0, tyProt *p1, int automode, int nresult,
                  float minscore, float proba_limite, float minrms,
                  float (*gscore)(int a1, int a2, void *matthresh), void *mat_thresh, float gap_o, float gap_e,
                  float tauxrecouv, float cross_rms_seuil, int vverbose, int SPN, WV *water_ving, int length, int elongation, float rrmsd, int which_rmsd)
{
    /* static int        callNewSWResult = 0; */
    SWResult     *swres = NULL;
    COORDS       **pp0 = NULL,**pp1 = NULL;
    int          *lensub = NULL;
    int          i, j, nn=0, nbpp=0;
    float        recover=0;

#ifdef MEMOIRE
    char *err_msg = NULL;
#endif

    if (SPN == STRUCTURE) {

        /* allocate for coords for rms     */
        lensub = NEWN(int, INCPP);
        pp0 = NEWN(COORDS *, INCPP);
        pp1 = NEWN(COORDS *, INCPP);

        if (!lensub || !pp0 || !pp1)
            MyError(stderr,3,"swalign:: not enough memory for RMS computations (pp0,pp1)\n");
        nbpp = INCPP;
    }   /*fin SPN == STRUCTURE*/
    else if (SPN== NUCLEIQUE) {
        gap_o = gap_o*SWADN_MULT;
        gap_e = gap_o*SWADN_MULT;
    }

    if ((swres = NewSWResult(p1)) == NULL)
        MyError(stderr, 4, "swalign:: not enough memory for swres!\n");

    /* fprintf(stderr,"call %d (sizeof SWResult %d)\n", ++callNewSWResult, (int)sizeof(SWResult)); */

#ifdef DEBUGYZ
    fprintf(stderr,"swres=%X\n",swres);
    fprintf(stderr,"swres->nmatch=%d\n",swres->nmatch);
    fprintf(stderr,"swres->realsize=%d\n",swres->realsize);
#endif

#ifdef MEMOIRE
    control_prog("./swelfe", getpid(), 1000000, 100000,&err_msg) ;
    fprintf(stderr, "memtest : avant alloc matrice \n");
    fflush(stderr);
#endif

    /*allocation de memoire pour la matrice m -> matrice d'alignement*/
    if (! sAliMat) {
        if ((sAliMat = NewMatrix(p0->nbRes + 1, p1->nbRes + 1)) == NULL)
            MyError(stderr,2,"swalign::not enough memory for NewMatrix\n");
    }

    else if (sAliMat->rsize <= (p0->nbRes+1)*(p1->nbRes+1)) {
        if (! (sAliMat = ReNewMatrix(sAliMat, p0->nbRes + 1, p1->nbRes + 1)))
            MyError(stderr,2,"swalign::not enough memory for NewMatrix\n");
    }
    else {
        sAliMat->n1 = p0->nbRes + 1;
        sAliMat->n2 = p1->nbRes + 1;
    }

#ifdef MEMOIRE
    control_prog("./swelfe", getpid(), 1000000, 100000,&err_msg) ;
    fprintf(stderr, "memtest : avant raz matrix \n");
    fflush(stderr);
#endif

    /* raz matrix   */
    memset((void *)(sAliMat->f), 0, sizeof(*(sAliMat->f))*(size_t)(sAliMat->rsize));
    memset((void *)(sAliMat->c), (int)ZERO, sizeof(*(sAliMat->c))*(size_t)(sAliMat->rsize));

    /*sPrintMatrix(m);*/

    /******************        carre SW             *********************/


    nn = carre_sw (swres, sAliMat, p0, p1,  automode, gap_o, gap_e, gscore, mat_thresh,
                   tauxrecouv,recover, vverbose, SPN, nresult, minscore, proba_limite, minrms,
                   cross_rms_seuil, &lensub, nbpp , &pp0, &pp1 , water_ving, length, elongation,
                   rrmsd, which_rmsd);




    if (SPN == STRUCTURE && swres->nmatch >= 1 ) {
        /* compute crossed RMS over an Swres   */
        /* debug jompo if (! (swres->crossrms = newcrossrmstab(swres->nmatch)) )  */
        if (! (swres->crossrms = NEWN(float *,swres->nmatch)) )
            MyError(stderr,3,"swalign:: not enough memory for crossed rms\n");

        for (i=0;i<swres->nmatch; i++) {
            /* debug jompo if (! (swres->crossrms[i] = newcrossrms(swres->nmatch)) )  */
            if (! (swres->crossrms[i] = NEWN(float,swres->nmatch)) )
                MyError(stderr,3,"swalign:: not enough memory for crossed rms\n");
        }

        for (i = 0; i < swres->nmatch ; i++) {

            /* rmsfast is done another time, to set  */
            /* the RT matrix in superpos.c       */
            /* OLD jompo: PAS BESOIN, rms deja calcule: rms = (float)sqrt(rms_fast(pp0[i],pp1[i],lensub[i])); */

            for (j = 0; j < swres->nmatch; j++) {

                /* rms_error returns the RMS with the  */
                /* actual RT matrix            */
                if (j==i)
                    swres->crossrms[i][j] = 0.0L;
                else
                    swres->crossrms[i][j] = (float)sqrt(zuker_superpose(pp0[j], pp1[j], lensub[j], swres->matrix4x[i]));
                /*     swres->crossrms[i][j] = (float)compute_RMS(pp0[j], pp1[j], lensub[j], swres->matrix4x[i]);*/
            }
        }

        /* debug jompo if (! (swres->group = newgroup(swres->nmatch)) ) */
        if (! (swres->group = NEWN(int, swres->nmatch)) )
            MyError(stderr,3,"swalign:: not enough memory for group\n");

        /* compute group of compatibles    */
        makegroup(0, swres->nmatch, swres->crossrms, swres->group, &(swres->ngroup), cross_rms_seuil);
        /* fprintf(stderr, "nombre groupe = %d\n",swres->ngroup); */

    }
    else {

        swres->crossrms = NULL;
        swres->group = NULL;
    }


    if (SPN == STRUCTURE) {
        /* free only pp's which have been allocated */
        for (i = 0; i < nn; i++) {
            if (pp0[i])
                free(pp0[i]);
            if (pp1[i])
                free(pp1[i]);
        }
        free(pp0);
        free(pp1);
        free(lensub);

    }
    return swres;
}

