
/* //////////////  Importation Standards   ///////// */

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "macros.h"
#include "libabiutils.h"	/* for MyError	*/

#define IS_LOWER(c)       (((c) >= 'a') && ((c) <= 'z'))
#define IS_UPPER(c)       (((c) >= 'A') && ((c) <= 'Z'))
#define TO_UPPER(c)         ((c) - 'a' + 'A')

/* ---------------------------------------------------- */
/* reverse a string					*/
/* ---------------------------------------------------- */
void StringReverse(char *s)
{
   int	j = strlen(s) - 1, i = 0;
   char	c;

   while (i < j) {
      c = s[i];
      s[i++] = s[j];
      s[j--] = c;
   }

   return;
}

/* ---------------------------------------------------- */
/* checking the sequence                                */
/* ---------------------------------------------------- */

int checkSeq(char *seq, int iseq, char *vocab)
{
        char    *c;

        for (c = seq ; *c ; c++){
           if (islower(*c))
                        *c = toupper(*c);
           if (! strchr(vocab, *c)) {
                return 0;
           }
        }

        return 1;
}

/* -------------------------------------------- */
/* open a file and assign it to stdin		*/
/* -------------------------------------------- */

int AssignToStdin(char *filename)
{
    char buffer[256];
	
    if (! freopen(filename, "r", stdin)) {
		sprintf(buffer, "cant open file %s to read", filename);
		MyError(stderr,0,buffer);
		return 0;
    }

    return 1;
}

/* -------------------------------------------- */
/* open a file and assign it to stdin		*/
/* -------------------------------------------- */

int ReAssignToStdin(char *filename)
{
    char buffer[256];

	if (! freopen(filename, "r+", stdin)) {
		sprintf(buffer, "cant open file %s to read", filename);
                MyError(stderr,0,buffer);
		return 0;
    }

    return 1;
}

/* -------------------------------------------- */
/* error reporting                              */
/* -------------------------------------------- */

int Error(char *msg, int stat)
{
        fprintf(stderr, "*Error* [%d] %s\n", stat, msg);
        if (stat)
           exit(stat);

        fflush(stderr);
        return stat;

}                                                                                                     

/* -------------------------------------------- */
/* uppercase sequence                           */
/* -------------------------------------------- */
char *Upper(char *seq)
{
        char *s;

        for (s = seq; *s ; s++)
           if (islower(*s))
                *s = toupper(*s);

        return seq;
}                                                                                                    

#if 0

/*********************************************/
/*Enlever tous caracteres speciaux           */
/*(code ASCII<32)d'une chaine de caracteres */
/*Renvoie le nombre d'espaces enleves        */
/*********************************************/
int RemoveSpecialChar(char *s)
{

  char *s2=NULL;
  int is, is2=0;
  int lgs;

  lgs=strlen(s);

  s2=NEWN(char, lgs+1);
  if(s2==NULL)
    MyError(stderr, 1, "not enough memory for string in RemoveSpecialChar\n");


  for(is=0; is<lgs; is++)
    {
      if((int)s[is] >= 32)
	{
	  s2[is2]=s[is];
	  is2++;
	}

    }

  s2[is2]='\000';
  strcpy(s, s2);

  free(s2);


  return(lgs-is2);
}
/*********************************************/
/*Enlever tous espaces                       */
/*(code ASCII=32)d'une chaine de caracteres  */
/*Renvoie le nombre d'espaces enleves        */
/*********************************************/
int RemoveSpace(char *s)
{

  char *s2=NULL;
  int is, is2=0;
  int lgs;

  lgs=strlen(s);

  s2=NEWN(char, lgs+1);
  if(s2==NULL)
    MyError(stderr, 1, "not enough memory for string in RemoveSpace\n");


  for(is=0; is<lgs; is++)
    {
      if((int)s[is] != 32)
	{
	  s2[is2]=s[is];
	  is2++;
	}

    }

  s2[is2]='\000';
  strcpy(s, s2);

  free(s2);


  return(lgs-is2);
}


#endif
